clear all 
close all
clc
%% Processing all energy, light results from different solar cells and computing tomato yield
%% Input parameters
% This is a sample file processing information for PTB7-Th:IEICO4F
% greenhouse for Anchorage, Alaska as location for 100 % OPV coverage
Anwins_cond=1; %North facing wall of greenhouse is insulated.
length=29.2608; %Length of greenhouse (m)
width=7.3152; %Width of greenhouse (m)
k=1;
totalcases1=1; %Total number of cases considered. Can be changed as needed. 
fracPAR_wall=zeros(8760,totalcases1); %fraction of PAR light intensity entering through the walls
pcov_all=zeros(totalcases1,1); %Roof coverage area of solar cells
totalcases=totalcases1;
% str1 represents list of all used solar cells
% str1=["PBDBT_CPDT4F";"PBDBT_CPDT4Cl";"D18_Y6";"PBDBT_ITIC";"J60_ITIC";"J61_ITIC";...
%     "J71_ITIC";"PTzBIDT_ITIC";"PBQ4F_ITIC";"PBZ_m_CF3_ITIC";"PBDT_S_2TC_ITIC";...
%     "PTzBI_ITIC";"PBPDTh_ITIC";"PTBFBZ_ITIC";"PDCBT_ITIC";"asy_PBDBTN_ITIC";...
%     "PTBTz2_ITIC";"HD_PBDT2FT_ITIC";"HFQx_T_ITIC";"PBTCl_ITIC";"PM6_ITIC";...
%     "PaNBDT_T1_ITIC";"PBDTTzBP_ITIC";"PBDTTZN_ITIC";"PBDTS_NQx_ITIC";"PBDTSF_FBT_ITIC";...
%     "PBDTS_TDZ_ITIC"; "3MTB_ITIC";"PDRCNBDT_ITIC";"PDTP4TFBT_ITIC";"PBDTsThPh_BDD_ITIC";"3MT-Th_ITIC";...
%     "PTzBITh_ITIC";"PBDBT_ITM";"PBDTBDD_ITICM"; "PDCBT2F_ITM";"PBDBT_IDTHN";...
%     "PBDBT_ITOM2";"PBTIBDTTS_ITICF";"PBDBTSF_IT4F";"PBDBTF_IT4F";"DRTBTC2_IT4F";...
%     "PM7_IT4F";"PDTBEFT_IT4F";"PBDBTF_IT2F_IT4F";"PBDBTF_IDTN";"PB3T_ITM";"FTAZ_INIC3";...
%     "PM6_IT4F";"PffBT4T_SFPDI2";"PTzBI_N2200";"PTB7TH_ITICTh";"PDBTT1_ITICTh";"PCE10_IDTBR_IDFBR";...
%     "PTB7TH_ITIC";"PTB7TH_CTIC4F";"PTB7TH_CO14F";"PTB7TH_COTIC4F";"PBDBT2F_IT4Cl";...
%     "PM6_Y6";"DPP2T_IEICO4F";"FTAZ_IEICO4F_PCBM";"PTB7TH_IEICO4F";"FTAZ_ITM"];

str1="PTB7TH_IEICO4F";

%str2 represents list of all used climates/locations
% str2=["SI";"CHI";"MI";"CH";"SAO";"EL";"JO";"DE";...
%     "LO";"UN";"GU";"JOH";"SE";"LE";"PY";"CAL";"YU";...
%     "SA";"SO";"AN";"MO";"AZ";"NC";"WI";"CA"];
str2="AN";

%str3 represents different roof coverage ratio percentages
%str3=["100";"80";"60";"40";"20"];
str3="100";
str4='.mat';
% str6='conv';
%absorption edge of all active layers selected
% absorptionedge_matrix=[910;910;910;750;750;750;750;750;750;750;750;750;750;750;750;...
%     750;750;750;750;750;750;750;750;750;750;750;750;750;750;750;750;750;750;740;740;...
%     740;660;740;770;760;760;760;760;760;760;750;740;780;760;730;780;740;740;750;...
%     740;910;1020;1120;790;870;950;950;950;740];
absorptionedge_matrix=950;
%band gap of all active layers selected
% bandgap_matrix=[1.31;1.25;1.41;1.31;1.51;1.51;1.51;1.61;1.56;1.64;1.63;1.56;1.57;...
%     1.61;1.33;1.48;1.51;1.51;1.62;1.71;1.65;1.62;1.42;1.4;1.48;1.58;1.56;1.31;...
%     1.34;1.48;1.56;1.31;1.41;1.35;1.35;1.62;1.47;1.47;1.44;1.26;1.26;1.37;1.45;1.37;...
%     1.54;1.5;1.43;1.5;1.4;1.53;1.5;1.27;1.43;1.54;1.4;1.2;1.1;1.1;1.38;1.4;0.91;1.14;...
%     1.05;1.38];
bandgap_matrix=1.05;
%absorption edge of donor organic semiconductor in the selected active
%layer.
% absorptionedge_donor_matrix=[650;650;625;650;620;590;610;615;540;600;570;...
%     750;630;640;620;650;760;600;700;680;665;600;620;615;570;700;580;630;660;710;...
%     640;570;650;650;650;585;650;650;655;650;650;605;670;615;650;650;640;600;665;...
%     730;650;745;660;750;745;745;745;745;650;660;850;600;745;600];
absorptionedge_donor_matrix=745;
p=1;
for i=1:1 %adjust to size of str1
    for j=1:1 %adjust to size of str2
        for k=1:1 %adjust to size of str3
            str5(p,:)=strcat(str1(i,:),'_',str2(j,:),'_',str3(k,:),str4);
            load(str5(p,:),'pcov','lightinput_wm2',...
            'th','T','Qtotalheat','ventilation_powerhour','Pouter','Poutwr','Pouterd',...
            'Poutwrd','Ac','Netenergywall','PCEernet','Fractionoflightineachwavelength');
            %[num,text,raw]=xlsread('Lettuceliterature_data.xlsx','phytotron_control'); %
            pcov_all(p,1)=pcov;
            absorptionedge(p,1)=absorptionedge_matrix(i,1);
            bandgap(p,1)=bandgap_matrix(i,1);
            absorptionedge_donor(p,1)=absorptionedge_donor_matrix(i,1);
            DailyPAR(:,p)=lightinput_wm2;
            PCEernet_all(p,1)=max(PCEernet(:,1));
            lightinputyear_plants_wall_wm2=0.5*0.75*(Netenergywall*0.432)/(length*width);
            for t=1:8760
                if(lightinputyear_plants_wall_wm2(t,1)>0)
                    fracPAR_wall(t,p)=lightinputyear_plants_wall_wm2(t,1)/lightinput_wm2(t,1);

                end
            end

            temp(:,p)=th(:,3);
            CO2(:,p)=450*ones(8760,1);
            T_all(:,p)=T(:,1);
            Qtotalheat_all(:,p)=Qtotalheat(:,1);
            ventilation_powerhour_all(:,p)=ventilation_powerhour(:,1);
            for t=1:8760
            Powertotal(t,1)=(((Pouter(t,1)+Poutwr(t,1))*(Ac/2))+((Pouterd(t,1)+Poutwrd(t,1))*(Ac/2)))/1000;
            end
            Powertotal_all(:,p)=Powertotal(:,1)*0.85;
            p=p+1;
        end
    end
end

%% lettuce parameters
Rd_20=40;
tau_25=40;
Rs=100;
Rbv=20;
plantingdensity = 18;
hourstotal=8760;
c_alpha = 0.68; %Converts assimilated CO2 into carbon
c_beta = 0.8; %Respiratory and synthesis loses of non structural material due to growth
cgrmax = 5e-6; %Saturation growth rate at 20C
c_gamma = 1; %Not known what this parameter means
cQ10 = 1.6; %Q10 factor for growth which has a value of 1.6
plant_DW_initial = 2.7; %Initial dry weight of lettuce (g/m2)
plant_DW_initial_norm = 2.7; %Initial dry weight of lettuce (g/m2)
plant_SDW_initial = 0.75*plant_DW_initial; %Initial structural dry weight of lettuce (g/m2)
plant_SDW_initial_norm = 0.75*plant_DW_initial_norm; 
%Initial structural dry weight of lettuce (g/m2)
plant_NSDW_initial = 0.25*plant_DW_initial; 
%Initial non-structural dry weight of lettuce (g/m2)
plant_NSDW_initial_norm = 0.25*plant_DW_initial_norm; 
%Initial structural dry weight of lettuce (g/m2)
Xsdw(1,1)=plant_SDW_initial; %Initial structural dry weight of lettuce (g/m2)
Xsdw_norm(1,1)=plant_SDW_initial_norm; %Initial structural dry weight of lettuce (g/m2)
Xnsdw(1,1)=plant_NSDW_initial; %Initial non structural dry weight of lettuce (g/m2)
Xnsdw_norm(1,1)=plant_NSDW_initial_norm; %Initial non structural dry weight of lettuce (g/m2)
cresp_sht=3.47e-7; %Coefficient of respiration for shoot
cresp_rt =1.16e-7; %Coefficient of respiration for root
cQ10_resp=2; %Q10 factor for respiration.
cQ10_tau = 2; %Q10 factor.
c_w = 1.83e-3; %Density of CO2 (g/m3) 
%For an wind speed of 0.1 m/s, a temperature difference of 5 0C,
%characteristic length of leaf 0.075 m, boundary layer conductance for CO2
%diffusion has a diffusion of 0.007 ms-1.
g_bnd=0.007; %Boundary layer conductance (m/s)
%For a temperature between 5 and 40 degrees.
c_car1=-1.32e-5;
c_car2=5.94e-4;
c_car3=-2.64e-3;
g_car_max=4e-3; %At 17.5 C
g_car_min = 0; %At 5 and 40 C
clustf=1;
kbl_nor=0.8; %LED lighting for urban agriculture page 128
sig=0.2;

%% Specific leaf area
% Light intensity and DLI for specific leaf area from literature
ppf1=20.1; 
ppf2=40.2;
ppf3=80.4;
ppf4=120.6;
ppf5=160.8;
DLI1=100*14*3600*1e-6;
DLI2=200*14*3600*1e-6;
DLI3=400*14*3600*1e-6;
DLI4=600*14*3600*1e-6;
DLI5=800*14*3600*1e-6;
phi_ps2_edit=[0.56,1,0.93,0.89,0.75]; %Quantum yield for photosynthesis
phi_ps2=zeros(8761,totalcases);
[num1,text,raw]=xlsread('sla_cope.xlsx','SLA_allcases_from20191219'); %specific leaf
%area as a function of spectra and light
num_ct=xlsread('percblue_root.xlsx'); %Root to shoot partitioning as a function 
%of spectra
c_larrecord=zeros(hourstotal+1,totalcases);
T_glass=0.9415*ones(341,1);
for j=1:totalcases
    k=1;
    M=341;
    fraclight1=zeros(M,1);
        for bb=1:M-1
            for p=(bb*5-4):(bb*5)
                fraclight1(bb,1)=fraclight1(bb,1) + Fractionoflightineachwavelength(p,1);     
            end
        end
        fraclight1(M,1)=Fractionoflightineachwavelength(p+1,1);
        fraclight=(pcov_all(j,1)*fraclight1.*T_all(:,j))+((1-pcov_all(j,1))*...
            fraclight1.*T_glass);
        fraclight_wall=fraclight1.*T_glass;
        fraclight_forT=fraclight;
        sumfraclight=sum(fraclight(:,1));
        fraclight=fraclight/sumfraclight;
        wlngth=300:5:2000;
        wlngth=wlngth';
        PAR_roof=sum(fraclight1(21:81,1));
        PAR_wall=sum(fraclight1(21:81,1));
        
        sumfracblue_roof(j,1)=sum(fraclight_forT(21:41,1));
        sumfracgreen_roof(j,1)=sum(fraclight_forT(42:61,1));
        sumfracred_roof(j,1)=sum(fraclight_forT(62:81,1));
        
        sumfracblue_wall(j,1)=sum(fraclight_wall(21:41,1));
        sumfracgreen_wall(j,1)=sum(fraclight_wall(42:61,1));
        sumfracred_wall(j,1)=sum(fraclight_wall(62:81,1));
        
        T_PAR_roof(j,1)=(sum((fraclight_forT(21:81,1)))/PAR_roof);
        T_PAR_wall(j,1)=(sum((fraclight_wall(21:81,1)))/PAR_wall);
        
        R_B_roof(j,1)= sumfracred_roof(j,1)/sumfracblue_roof(j,1);
        R_B_wall(j,1)= sumfracred_wall(j,1)/sumfracblue_wall(j,1);
        
        percblue_roof(j,1)=sumfracblue_roof(j,1)*100/(sumfracblue_roof(j,1)+sumfracgreen_roof(j,1)+sumfracred_roof(j,1));
        percblue_roof(j,1)=round(percblue_roof(j,1));
        percgreen_roof(j,1)=sumfracgreen_roof(j,1)*100/(sumfracblue_roof(j,1)+sumfracgreen_roof(j,1)+sumfracred_roof(j,1));
        percgreen_roof(j,1)=round(percgreen_roof(j,1));
        percred_roof(j,1)=sumfracred_roof(j,1)*100/(sumfracblue_roof(j,1)+sumfracgreen_roof(j,1)+sumfracred_roof(j,1));
        percred_roof(j,1)=round(percred_roof(j,1));
        percblue_wall(j,1)=sumfracblue_wall(j,1)*100/(sumfracblue_wall(j,1)+sumfracgreen_wall(j,1)+sumfracred_wall(j,1));
        percblue_wall(j,1)=round(percblue_wall(j,1));
        percgreen_wall(j,1)=sumfracgreen_wall(j,1)*100/(sumfracblue_wall(j,1)+sumfracgreen_wall(j,1)+sumfracred_wall(j,1));
        percgreen_wall(j,1)=round(percgreen_wall(j,1));
        percred_wall(j,1)=sumfracred_wall(j,1)*100/(sumfracblue_wall(j,1)+sumfracgreen_wall(j,1)+sumfracred_wall(j,1));
        percred_wall(j,1)=round(percred_wall(j,1));
for i=1:hourstotal
    if(DailyPAR(i,j)==0)
        R_B(i,j)=0; %Red to blue ratio
        T_PAR_avg(i,j)=0; %Transmittance of PAR light
        percblue(i,j)=0; %Percentage of blue light in spectra
        percgreen(i,j)=0; %Percentage of green light in spectra
        percred(i,j)=0; %Percentage of red light in spectra
    else
        R_B(i,j)=(R_B_roof(j,1)*(1-fracPAR_wall(i,j)))+...
            (R_B_wall(j,1)*(fracPAR_wall(i,j)));
        T_PAR_avg(i,j)=(T_PAR_roof(j,1)*(1-fracPAR_wall(i,j)))+...
            (T_PAR_wall(j,1)*(fracPAR_wall(i,j)));
        percblue(i,j)=(percblue_roof(j,1)*(1-fracPAR_wall(i,j)))+...
            (percblue_wall(j,1)*(fracPAR_wall(i,j)));
        percblue(i,j)=round(percblue(i,j));
        percgreen(i,j)=(percgreen_roof(j,1)*(1-fracPAR_wall(i,j)))+...
            (percgreen_wall(j,1)*(fracPAR_wall(i,j)));
        percgreen(i,j)=round(percgreen(i,j));
        percred(i,j)=(percred_roof(j,1)*(1-fracPAR_wall(i,j)))+...
            (percred_wall(j,1)*(fracPAR_wall(i,j)));
        percred(i,j)=round(percred(i,j));
    end
    %% Computing specific leaf area as a function of spectra and light intensity
if(R_B(i,j)==0)
    if(j>=1&&j<=totalcases1)
    c_lar1=num1(percblue(i,j)+1,2)*1e-3;
    c_lar2=num1(percblue(i,j)+1,3)*1e-3;
    c_lar3=num1(percblue(i,j)+1,4)*1e-3;
    c_lar4=num1(percblue(i,j)+1,5)*1e-3;
    c_lar5=num1(percblue(i,j)+1,6)*1e-3;
    end
    
    
    if(DailyPAR(i,j)==0)
        if(i==1||i==745||i==1417||i==2161||i==2881||i==3625||i==4345||i==5089||...
            i==5833||i==6553||i==7297||i==8017)
            c_larrecord(i,j)=0.075;
        else
            c_larrecord(i,j)=0.001;
        end
    else
        if(DailyPAR(i,j)<=ppf1&&DailyPAR(i,j)>0)
            c_larrecord(i,j)=c_lar1;
            phi_ps2(i,j)=phi_ps2_edit(1,1);
        end
        if(DailyPAR(i,j)>=ppf5)
            c_larrecord(i,j)=c_lar5;
            phi_ps2(i,j)=phi_ps2_edit(1,5);
        end
        if(DailyPAR(i,j)<=ppf2&&DailyPAR(i,j)>ppf1)
            c_larrecord(i,j)=c_lar1+(((c_lar2-c_lar1)/(ppf2-ppf1))*(DailyPAR(i,j)-ppf1));
            phi_ps2(i,j)=phi_ps2_edit(1,1)+(((phi_ps2_edit(1,2)-phi_ps2_edit(1,1))/(ppf2-ppf1))*(DailyPAR(i,j)-ppf1));
            %c_larrecord(i,j)=c_lar1;
        end
        if(DailyPAR(i,j)<=ppf3&&DailyPAR(i,j)>ppf2)
            c_larrecord(i,j)=c_lar2+(((c_lar3-c_lar2)/(ppf3-ppf2))*(DailyPAR(i,j)-ppf2));
            phi_ps2(i,j)=phi_ps2_edit(1,2)+(((phi_ps2_edit(1,3)-phi_ps2_edit(1,2))/(ppf3-ppf2))*(DailyPAR(i,j)-ppf2));
        end
        if(DailyPAR(i,j)<=ppf4&&DailyPAR(i,j)>ppf3)
            c_larrecord(i,j)=c_lar3+(((c_lar4-c_lar3)/(ppf4-ppf3))*(DailyPAR(i,j)-ppf3));
            phi_ps2(i,j)=phi_ps2_edit(1,3)+(((phi_ps2_edit(1,4)-phi_ps2_edit(1,3))/(ppf4-ppf3))*(DailyPAR(i,j)-ppf3));
        end
        if(DailyPAR(i,j)<=ppf5&&DailyPAR(i,j)>ppf4)
            c_larrecord(i,j)=c_lar4+(((c_lar5-c_lar4)/(ppf5-ppf4))*(DailyPAR(i,j)-ppf4));
            phi_ps2(i,j)=phi_ps2_edit(1,4)+(((phi_ps2_edit(1,5)-phi_ps2_edit(1,4))/(ppf5-ppf4))*(DailyPAR(i,j)-ppf4));
        end
    end
  multfact_Fmm(i,j)=2.15; %Spectral factor for computing maximum rate of 
  %photosynthesis
  g_stm=0.012; 
  
end
if(R_B(i,j)>12)
     if(j>=1&&j<=totalcases1)
    c_lar1=num1(percblue(i,j)+1,2)*1e-3;
    c_lar2=num1(percblue(i,j)+1,3)*1e-3;
    c_lar3=num1(percblue(i,j)+1,4)*1e-3;
    c_lar4=num1(percblue(i,j)+1,5)*1e-3;
    c_lar5=num1(percblue(i,j)+1,6)*1e-3;
    end
    
    if(DailyPAR(i,j)==0)
        if(i==1||i==745||i==1417||i==2161||i==2881||i==3625||i==4345||i==5089||...
            i==5833||i==6553||i==7297||i==8017)
            c_larrecord(i,j)=0.075;
        else
            c_larrecord(i,j)=0.001;
        end
    else
        if(DailyPAR(i,j)<=ppf1&&DailyPAR(i,j)>0)
            c_larrecord(i,j)=c_lar1;
            phi_ps2(i,j)=phi_ps2_edit(1,1);
        end
        if(DailyPAR(i,j)>=ppf5)
            c_larrecord(i,j)=c_lar5;
            phi_ps2(i,j)=phi_ps2_edit(1,5);
        end
        if(DailyPAR(i,j)<=ppf2&&DailyPAR(i,j)>ppf1)
            c_larrecord(i,j)=c_lar1+(((c_lar2-c_lar1)/(ppf2-ppf1))*(DailyPAR(i,j)-ppf1));
            phi_ps2(i,j)=phi_ps2_edit(1,1)+(((phi_ps2_edit(1,2)-phi_ps2_edit(1,1))/(ppf2-ppf1))*(DailyPAR(i,j)-ppf1));
            %c_larrecord(i,j)=c_lar1;
        end
        if(DailyPAR(i,j)<=ppf3&&DailyPAR(i,j)>ppf2)
            c_larrecord(i,j)=c_lar2+(((c_lar3-c_lar2)/(ppf3-ppf2))*(DailyPAR(i,j)-ppf2));
            phi_ps2(i,j)=phi_ps2_edit(1,2)+(((phi_ps2_edit(1,3)-phi_ps2_edit(1,2))/(ppf3-ppf2))*(DailyPAR(i,j)-ppf2));
        end
        if(DailyPAR(i,j)<=ppf4&&DailyPAR(i,j)>ppf3)
            c_larrecord(i,j)=c_lar3+(((c_lar4-c_lar3)/(ppf4-ppf3))*(DailyPAR(i,j)-ppf3));
            phi_ps2(i,j)=phi_ps2_edit(1,3)+(((phi_ps2_edit(1,4)-phi_ps2_edit(1,3))/(ppf4-ppf3))*(DailyPAR(i,j)-ppf3));
        end
        if(DailyPAR(i,j)<=ppf5&&DailyPAR(i,j)>ppf4)
            c_larrecord(i,j)=c_lar4+(((c_lar5-c_lar4)/(ppf5-ppf4))*(DailyPAR(i,j)-ppf4));
            phi_ps2(i,j)=phi_ps2_edit(1,4)+(((phi_ps2_edit(1,5)-phi_ps2_edit(1,4))/(ppf5-ppf4))*(DailyPAR(i,j)-ppf4));
        end
    end
  f_photmaxfactor=1;
  multfact_Fmm(i,j)=1.29;
  g_stm=0.002;
end
if(R_B(i,j)>0&&R_B(i,j)<=1)
     if(j>=1&&j<=totalcases1)
    c_lar1=num1(percblue(i,j)+1,2)*1e-3;
    c_lar2=num1(percblue(i,j)+1,3)*1e-3;
    c_lar3=num1(percblue(i,j)+1,4)*1e-3;
    c_lar4=num1(percblue(i,j)+1,5)*1e-3;
    c_lar5=num1(percblue(i,j)+1,6)*1e-3;
    end
   
    if(DailyPAR(i,j)==0)
        if(i==1||i==745||i==1417||i==2161||i==2881||i==3625||i==4345||i==5089||...
            i==5833||i==6553||i==7297||i==8017)
            c_larrecord(i,j)=0.075;
        else
            c_larrecord(i,j)=0.001;
        end
    else
        if(DailyPAR(i,j)<=ppf1&&DailyPAR(i,j)>0)
            c_larrecord(i,j)=c_lar1;
            phi_ps2(i,j)=phi_ps2_edit(1,1);
        end
        if(DailyPAR(i,j)>=ppf5)
            c_larrecord(i,j)=c_lar5;
            phi_ps2(i,j)=phi_ps2_edit(1,5);
        end
        if(DailyPAR(i,j)<=ppf2&&DailyPAR(i,j)>ppf1)
            c_larrecord(i,j)=c_lar1+(((c_lar2-c_lar1)/(ppf2-ppf1))*(DailyPAR(i,j)-ppf1));
            phi_ps2(i,j)=phi_ps2_edit(1,1)+(((phi_ps2_edit(1,2)-phi_ps2_edit(1,1))/(ppf2-ppf1))*(DailyPAR(i,j)-ppf1));
            %c_larrecord(i,j)=c_lar1;
        end
        if(DailyPAR(i,j)<=ppf3&&DailyPAR(i,j)>ppf2)
            c_larrecord(i,j)=c_lar2+(((c_lar3-c_lar2)/(ppf3-ppf2))*(DailyPAR(i,j)-ppf2));
            phi_ps2(i,j)=phi_ps2_edit(1,2)+(((phi_ps2_edit(1,3)-phi_ps2_edit(1,2))/(ppf3-ppf2))*(DailyPAR(i,j)-ppf2));
        end
        if(DailyPAR(i,j)<=ppf4&&DailyPAR(i,j)>ppf3)
            c_larrecord(i,j)=c_lar3+(((c_lar4-c_lar3)/(ppf4-ppf3))*(DailyPAR(i,j)-ppf3));
            phi_ps2(i,j)=phi_ps2_edit(1,3)+(((phi_ps2_edit(1,4)-phi_ps2_edit(1,3))/(ppf4-ppf3))*(DailyPAR(i,j)-ppf3));
        end
        if(DailyPAR(i,j)<=ppf5&&DailyPAR(i,j)>ppf4)
            c_larrecord(i,j)=c_lar4+(((c_lar5-c_lar4)/(ppf5-ppf4))*(DailyPAR(i,j)-ppf4));
            phi_ps2(i,j)=phi_ps2_edit(1,4)+(((phi_ps2_edit(1,5)-phi_ps2_edit(1,4))/(ppf5-ppf4))*(DailyPAR(i,j)-ppf4));
        end
    end
  f_photmaxfactor=1;
  %c_epsilon(i,j) = 34+(((36-34)/(1-0))*(R_B(i,j)-0)); %Light use efficiency at very high CO2 
  multfact_Fmm(i,j)=2.15+(((2.25-2.15)/(1-0))*(R_B(i,j)));
  g_stm=0.012+(((0.008-0.012)/(1-0))*(R_B(i,j)));
end

if(R_B(i,j)>1&&R_B(i,j)<=4)
    if(j>=1&&j<=totalcases1)
    c_lar1=num1(percblue(i,j)+1,2)*1e-3;
    c_lar2=num1(percblue(i,j)+1,3)*1e-3;
    c_lar3=num1(percblue(i,j)+1,4)*1e-3;
    c_lar4=num1(percblue(i,j)+1,5)*1e-3;
    c_lar5=num1(percblue(i,j)+1,6)*1e-3;
    end
   
   
    if(DailyPAR(i,j)==0)
        if(i==1||i==745||i==1417||i==2161||i==2881||i==3625||i==4345||i==5089||...
            i==5833||i==6553||i==7297||i==8017)
            c_larrecord(i,j)=0.075;
        else
            c_larrecord(i,j)=0.001;
        end
    else
        if(DailyPAR(i,j)<=ppf1&&DailyPAR(i,j)>0)
            c_larrecord(i,j)=c_lar1;
            phi_ps2(i,j)=phi_ps2_edit(1,1);
        end
        if(DailyPAR(i,j)>=ppf5)
            c_larrecord(i,j)=c_lar5;
            phi_ps2(i,j)=phi_ps2_edit(1,5);
        end
        if(DailyPAR(i,j)<=ppf2&&DailyPAR(i,j)>ppf1)
            c_larrecord(i,j)=c_lar1+(((c_lar2-c_lar1)/(ppf2-ppf1))*(DailyPAR(i,j)-ppf1));
            phi_ps2(i,j)=phi_ps2_edit(1,1)+(((phi_ps2_edit(1,2)-phi_ps2_edit(1,1))/(ppf2-ppf1))*(DailyPAR(i,j)-ppf1));
            %c_larrecord(i,j)=c_lar1;
        end
        if(DailyPAR(i,j)<=ppf3&&DailyPAR(i,j)>ppf2)
            c_larrecord(i,j)=c_lar2+(((c_lar3-c_lar2)/(ppf3-ppf2))*(DailyPAR(i,j)-ppf2));
            phi_ps2(i,j)=phi_ps2_edit(1,2)+(((phi_ps2_edit(1,3)-phi_ps2_edit(1,2))/(ppf3-ppf2))*(DailyPAR(i,j)-ppf2));
        end
        if(DailyPAR(i,j)<=ppf4&&DailyPAR(i,j)>ppf3)
            c_larrecord(i,j)=c_lar3+(((c_lar4-c_lar3)/(ppf4-ppf3))*(DailyPAR(i,j)-ppf3));
            phi_ps2(i,j)=phi_ps2_edit(1,3)+(((phi_ps2_edit(1,4)-phi_ps2_edit(1,3))/(ppf4-ppf3))*(DailyPAR(i,j)-ppf3));
        end
        if(DailyPAR(i,j)<=ppf5&&DailyPAR(i,j)>ppf4)
            c_larrecord(i,j)=c_lar4+(((c_lar5-c_lar4)/(ppf5-ppf4))*(DailyPAR(i,j)-ppf4));
            phi_ps2(i,j)=phi_ps2_edit(1,4)+(((phi_ps2_edit(1,5)-phi_ps2_edit(1,4))/(ppf5-ppf4))*(DailyPAR(i,j)-ppf4));
        end
    end
  multfact_Fmm(i,j)=2.25+(((2.06-2.25)/(4-1))*(R_B(i,j)-1));
  g_stm=0.008+(((0.007-0.008)/(4-1))*(R_B(i,j)-1));  
end
 if(R_B(i,j)>4&&R_B(i,j)<=8)
        if(j>=1&&j<=totalcases1)
    c_lar1=num1(percblue(i,j)+1,2)*1e-3;
    c_lar2=num1(percblue(i,j)+1,3)*1e-3;
    c_lar3=num1(percblue(i,j)+1,4)*1e-3;
    c_lar4=num1(percblue(i,j)+1,5)*1e-3;
    c_lar5=num1(percblue(i,j)+1,6)*1e-3;
        end

     if(DailyPAR(i,j)==0)
         % harvest is considered every month
        if(i==1||i==745||i==1417||i==2161||i==2881||i==3625||i==4345||i==5089||...
            i==5833||i==6553||i==7297||i==8017)
            c_larrecord(i,j)=0.075;
        else
            c_larrecord(i,j)=0.001;
        end
    else
        if(DailyPAR(i,j)<=ppf1&&DailyPAR(i,j)>0)
            c_larrecord(i,j)=c_lar1;
            phi_ps2(i,j)=phi_ps2_edit(1,1);
        end
        if(DailyPAR(i,j)>=ppf5)
            c_larrecord(i,j)=c_lar5;
            phi_ps2(i,j)=phi_ps2_edit(1,5);
        end
        if(DailyPAR(i,j)<=ppf2&&DailyPAR(i,j)>ppf1)
            c_larrecord(i,j)=c_lar1+(((c_lar2-c_lar1)/(ppf2-ppf1))*(DailyPAR(i,j)-ppf1));
            phi_ps2(i,j)=phi_ps2_edit(1,1)+(((phi_ps2_edit(1,2)-phi_ps2_edit(1,1))/(ppf2-ppf1))*(DailyPAR(i,j)-ppf1));
        end
        if(DailyPAR(i,j)<=ppf3&&DailyPAR(i,j)>ppf2)
            c_larrecord(i,j)=c_lar2+(((c_lar3-c_lar2)/(ppf3-ppf2))*(DailyPAR(i,j)-ppf2));
            phi_ps2(i,j)=phi_ps2_edit(1,2)+(((phi_ps2_edit(1,3)-phi_ps2_edit(1,2))/(ppf3-ppf2))*(DailyPAR(i,j)-ppf2));
        end
        if(DailyPAR(i,j)<=ppf4&&DailyPAR(i,j)>ppf3)
            c_larrecord(i,j)=c_lar3+(((c_lar4-c_lar3)/(ppf4-ppf3))*(DailyPAR(i,j)-ppf3));
            phi_ps2(i,j)=phi_ps2_edit(1,3)+(((phi_ps2_edit(1,4)-phi_ps2_edit(1,3))/(ppf4-ppf3))*(DailyPAR(i,j)-ppf3));
        end
        if(DailyPAR(i,j)<=ppf5&&DailyPAR(i,j)>ppf4)
            c_larrecord(i,j)=c_lar4+(((c_lar5-c_lar4)/(ppf5-ppf4))*(DailyPAR(i,j)-ppf4));
            phi_ps2(i,j)=phi_ps2_edit(1,4)+(((phi_ps2_edit(1,5)-phi_ps2_edit(1,4))/(ppf5-ppf4))*(DailyPAR(i,j)-ppf4));
        end
     end
   multfact_Fmm(i,j)=2.06+(((1.68-2.06)/(8-4))*(R_B(i,j)-4));
   g_stm=0.007+(((0.0042-0.007)/(8-4))*(R_B(i,j)-4));
 end
 if(R_B(i,j)>8&&R_B(i,j)<=12)
        if(j>=1&&j<=totalcases1)
    c_lar1=num1(percblue(i,j)+1,2)*1e-3;
    c_lar2=num1(percblue(i,j)+1,3)*1e-3;
    c_lar3=num1(percblue(i,j)+1,4)*1e-3;
    c_lar4=num1(percblue(i,j)+1,5)*1e-3;
    c_lar5=num1(percblue(i,j)+1,6)*1e-3;
    end
    
     if(DailyPAR(i,j)==0)
        if(i==1||i==745||i==1417||i==2161||i==2881||i==3625||i==4345||i==5089||...
            i==5833||i==6553||i==7297||i==8017)
            c_larrecord(i,j)=0.075;
        else
            c_larrecord(i,j)=0.001;
        end
    else
        if(DailyPAR(i,j)<=ppf1&&DailyPAR(i,j)>0)
            c_larrecord(i,j)=c_lar1;
            phi_ps2(i,j)=phi_ps2_edit(1,1);
        end
        if(DailyPAR(i,j)>=ppf5)
            c_larrecord(i,j)=c_lar5;
            phi_ps2(i,j)=phi_ps2_edit(1,5);
        end
        if(DailyPAR(i,j)<=ppf2&&DailyPAR(i,j)>ppf1)
            c_larrecord(i,j)=c_lar1+(((c_lar2-c_lar1)/(ppf2-ppf1))*(DailyPAR(i,j)-ppf1));
            phi_ps2(i,j)=phi_ps2_edit(1,1)+(((phi_ps2_edit(1,2)-phi_ps2_edit(1,1))/(ppf2-ppf1))*(DailyPAR(i,j)-ppf1));
            %c_larrecord(i,j)=c_lar1;
        end
        if(DailyPAR(i,j)<=ppf3&&DailyPAR(i,j)>ppf2)
            c_larrecord(i,j)=c_lar2+(((c_lar3-c_lar2)/(ppf3-ppf2))*(DailyPAR(i,j)-ppf2));
            phi_ps2(i,j)=phi_ps2_edit(1,2)+(((phi_ps2_edit(1,3)-phi_ps2_edit(1,2))/(ppf3-ppf2))*(DailyPAR(i,j)-ppf2));
        end
        if(DailyPAR(i,j)<=ppf4&&DailyPAR(i,j)>ppf3)
            c_larrecord(i,j)=c_lar3+(((c_lar4-c_lar3)/(ppf4-ppf3))*(DailyPAR(i,j)-ppf3));
            phi_ps2(i,j)=phi_ps2_edit(1,3)+(((phi_ps2_edit(1,4)-phi_ps2_edit(1,3))/(ppf4-ppf3))*(DailyPAR(i,j)-ppf3));
        end
        if(DailyPAR(i,j)<=ppf5&&DailyPAR(i,j)>ppf4)
            c_larrecord(i,j)=c_lar4+(((c_lar5-c_lar4)/(ppf5-ppf4))*(DailyPAR(i,j)-ppf4));
            phi_ps2(i,j)=phi_ps2_edit(1,4)+(((phi_ps2_edit(1,5)-phi_ps2_edit(1,4))/(ppf5-ppf4))*(DailyPAR(i,j)-ppf4));
        end
    end
    multfact_Fmm(i,j)=1.68+(((1.6-1.68)/(12-8))*(R_B(i,j)-8));
    g_stm=0.0042+(((0.003-0.0042)/(12-8))*(R_B(i,j)-8));   
 end
  c_epsilon(i,j)=15; %1.36 to get the minimum value up to 25 Goudriaan 1985
end

end



%% Extinction coefficient calculation

[num,text,raw]=xlsread('plant_transmittance_reflectance.xlsx');
wavelength1=num(:,1); %Tempoarary storage for wavelength (nm)
wavelength1(isnan(wavelength1)) = [];
ref_plant1=num(:,2); %Temporary storage for reflectance of plant 
ref_plant1(isnan(ref_plant1)) = [];
wavelength=400:5:700; %Wavelength (nm)
wavelength=wavelength';
ref_plant=interp1(wavelength1,ref_plant1,wavelength); %Reflectance of plant
ref_plant=ref_plant/100;
wavelength2=num(:,3); %Tempoarary storage for wavelength (nm)
wavelength2(isnan(wavelength2)) = [];
tnsmvty_plant1=num(:,4); %Temporary storage for transmittance of plant 
tnsmvty_plant1(isnan(tnsmvty_plant1)) = [];
tnsmvty_plant=interp1(wavelength2,tnsmvty_plant1,wavelength); %Transmittance 
%of plant
tnsmvty_plant=tnsmvty_plant/100; %Transmittance 
% %of plant
sig1=tnsmvty_plant+ref_plant; %Scattering coefficient
sqv=sqrt(1-sig1); %Temporary variable utilized in calculating 
%Reflection coefficient of the canopy for diffuse and direct radiation
kbl=kbl_nor; %Extinction coefficient of leaves for direct radiation of light


%% Iterative loop

%% Slope for photosynthesis as a function of spectra
num_theta1=xlsread('theta.xlsx','R_B_0');
num_theta2=xlsread('theta.xlsx','R_B_1');
num_theta3=xlsread('theta.xlsx','R_B_4');
num_theta4=xlsread('theta.xlsx','R_B_8');
num_theta5=xlsread('theta.xlsx','R_B_12');
num_theta6=xlsread('theta.xlsx','R');

for j=1:totalcases
    i=1; 
    plant_DW_initial = 2.7;
    plant_SDW_initial = 0.75*plant_DW_initial;
    plant_NSDW_initial = 0.25*plant_DW_initial;
    Xsdw(i,j)=plant_SDW_initial;
    Xnsdw(i,j)=plant_NSDW_initial;
    k=1;
while i<=hourstotal
    it=i
    c_lar_hour=c_larrecord(i,j);
    lar_record(i,j)=c_lar_hour;
    if(i==745||i==1417||i==2161||i==2881||i==3625||i==4345||i==5089||...
            i==5833||i==6553||i==7297||i==8017)
        Xsdw(i,j)=plant_SDW_initial;
        Xnsdw(i,j)=plant_NSDW_initial;
        c_lar_hour=c_larrecord(1,j);
        lar_record(i,j)=c_lar_hour;
        cycle_harvest(k,j)=Ydw(i-1,j);
        cycle_harvest_leafarea(k,j)=Ylai(i-1,j);
        k=k+1
    end
    %Mesophyll conductance
    if(temp(i,j)==0)
        Gm(i,1)=0;
    else
        if(temp(i,j)>0&&temp(i,j)<=2)
            Gm(i,1)=0;
        else
            if(temp(i,j)>2&&temp(i,j)<=25)
                Gm(i,1)=(0.005/23)*(temp(i,j)-2);
            else
                if(temp(i,j)>25&&temp(i,j)<=39)
                    Gm(i,1)=0.005-((0.005/14)*(temp(i,j)-25));
                else
                    if(temp(i,j)>39)
                        Gm(i,1)=0;
                    end
                end
            end
        end
    end
    Rd(i,1)=Rd_20*exp(0.07*(temp(i,j)-20)); %%Respiration loss as a function of 
    %temperature
    %Maximum rate of photosynthesis
    Fmm(i,1)=(-4.43+(2.11*temp(i,j))-(0.0438*(temp(i,j)*temp(i,j))))* multfact_Fmm(i,j); %Reference unknown but fit is empirical similar to page 163 in Goudrian 
    Fmm(i,1)=(Fmm(i,1)*1000*1e6/(3600*10000)); %No -Rd here. That's Fnc.
    Rm(i,1)=1/Gm(i,1); %Mesophyll conductance 
    if(DailyPAR(i,j)==0)
        rgr = (((cgrmax*(Xnsdw(i,j)))/((c_gamma*Xsdw(i,j))+Xnsdw(i,j)))*...
        (cQ10^((temp(i,j)-20)/10))); %Growth rate
        c_t=num_ct(percblue(i,j)+1,1);
        fresp = (((cresp_sht*(1-c_t)*Xsdw(i,j))+(cresp_rt*c_t*Xsdw(i,j)))*...
        (cQ10_resp^((temp(i,j)-25)/10))); %Maintenance respiration rate of the crop
        %tau = c_tau*(cQ10_tau^((temp(i,j)-20)/10)); %CO2 compensation point
        tau_2=tau_25*(cQ10_tau^((temp(i,j)-20)/10));
        epsilon=c_epsilon(i,j)*((CO2(i,j)-tau_2)/(CO2(i,j)+(2*tau_2)));
        %epsilon = c_epsilon(i,j)*(CO2(i,j)-tau)/(CO2(i,j)+(2*tau));%Light use efficiency 
        g_car=(c_car1*(temp(i,j)^2))+(c_car2*temp(i,j))+(c_car3);
        g_CO2_inv = (1/g_bnd)+(1/g_stm)+(1/g_car);
        g_CO2=1/g_CO2_inv;
        f_photmax= ((epsilon*(DailyPAR(i,j))*g_CO2*c_w*(CO2(i,j)-tau_2))...
        /((epsilon*(DailyPAR(i,j)))+(g_CO2*c_w*(CO2(i,j)-tau_2))));
        f_photmax=min(f_photmax,Fmm(i,1));
        f_photmax_record(i,j)=f_photmax;
        if(i==1||i==745||i==1417||i==2161||i==2881||i==3625||i==4345||i==5089||...
            i==5833||i==6553||i==7297||i==8017)
        LAI_record(i,j)=c_lar_hour*(Xsdw(i,j)+Xnsdw(i,j)); %Leaf area index
        else
            LAI_record(i,j)=LAI_record(i-1,j)+(c_lar_hour*((Xsdw(i,j)+Xnsdw(i,j))-...
                (Xsdw(i-1,j)+Xnsdw(i-1,j))));
        end
        kdf=(0.178*exp(-1.93*LAI_record(i,j)))+(0.514*exp(-0.707*LAI_record(i,j)))+...
            (0.308*exp(-0.518*LAI_record(i,j))); %Diffuse extinction coefficient
        kdf=-log(kdf);
        kdf=kdf/LAI_record(i,j);
        refh=(1-sqrt(1-sig))/(1+sqrt(1-sig));%reflection coefficient
        refs=(2*kbl/(kbl+kdf))*refh; %reflection coefficient
        PARdf=DailyPAR(i,j)*0.5; %Diffuse radiation
        PARdr=DailyPAR(i,j)*0.5; %Direct radiation
        
        % Gaussian distribution for photosynthesis
        wt(1,1)=0.1184635;
        wt(2,1)=0.2393144;
        wt(3,1)=0.2844444;
        wt(4,1)=0.2393144;
        wt(5,1)=0.1184635;
        dist(1,1)=0.0469101;
        dist(2,1)=0.2307534;
        dist(3,1)=0.5;
        dist(4,1)=0.7692465;
        dist(5,1)=0.9530899;
        %leaf area distribution
        laic=[LAI_record(i,j)*dist(1,1);LAI_record(i,j)*dist(2,1);LAI_record(i,j)*dist(3,1);...
            LAI_record(i,j)*dist(4,1);LAI_record(i,j)*dist(5,1)];
        
        %% Photosynthesis calculation
        Fgros=0;
        for p=1:5
        visdf=(1-refh)*PARdf*kdf*exp(-kdf*laic(p,1));
        vist=(1-refs)*PARdr*kbl*sqrt(1-sig)*exp(-kbl*sqrt(1-sig)*laic(p,1));
        visd=(1-sig)*PARdr*kbl*exp(-kbl*laic(p,1));
        visshd=visdf+vist-visd;
        vispp=(1-sig)*PARdr;
        vissun=(vispp*dist(p,1))+(visshd);
        fslla=exp(-kbl*laic(p,1));
        eI_fmax_shd=0;
        eI_fmax_sun=0;
        theta=0.7;
        fact1_shd=1+eI_fmax_shd;
        fact1_sun=1+eI_fmax_sun;
        fact2_shd=4*eI_fmax_shd*theta;
        fact2_sun=4*eI_fmax_sun*theta;
        fact3_shd=sqrt((fact1_shd)^2-fact2_shd);
        fact3_sun=sqrt((fact1_sun)^2-fact2_sun);
        y_shd=(fact1_shd-fact3_shd)/(2*theta);
        y_sun=(fact1_sun-fact3_sun)/(2*theta);
        Fn_shd=y_shd*f_photmax;
        Fn_sun=y_sun*f_photmax;
        Fgros1=((fslla*Fn_sun)+((1-fslla)*Fn_shd))*wt(p,1);
        Fgros=Fgros+Fgros1; % Net assimilation rate (microg m-2 s-1)
        end
        Fphot=Fgros*LAI_record(i,j); %Total assimilation accounting for LAI
        Xnsdw(i+1,j)=Xnsdw(i,j)+(c_alpha*Fphot*1e-6*3600-(rgr*3600*Xsdw(i,j))-fresp*3600-...
        ((1-c_beta)/c_beta)*rgr*3600*Xsdw(i,j)); %Change in plant weight (g/m2)
        Xsdw(i+1,j)=Xsdw(i,j)+(rgr*3600*Xsdw(i,j)); %Change in plant weight (g/m2)
        i=i+1;
    else
        % Same as the case when there is no sunlight
        fraclight_rel=fraclight(21:81,1)/sum(fraclight(21:81,1));
        Netenergy(:,i)=DailyPAR(i,j)*fraclight_rel;
        Netenergyv(:,i)=Netenergy(:,i);
        kbl_weighed(:,1)=(Netenergyv(:,i).*kbl(:,1))/...
            sum(Netenergyv(:,i));
        kbl_wd(i,1)=sum(kbl_weighed(:,1));
        c_K=kbl_wd(i,1);
        rgr = (((cgrmax*(Xnsdw(i,j)))/((c_gamma*Xsdw(i,j))+Xnsdw(i,j)))*...
            (cQ10^((temp(i,j)-20)/10))); %Growth rate
        c_t=num_ct(percblue(i,j)+1,1);
        fresp = (((cresp_sht*(1-c_t)*Xsdw(i,j))+(cresp_rt*c_t*Xsdw(i,j)))*...
            (cQ10_resp^((temp(i,j)-25)/10))); %Maintenance respiration rate of the crop
        %tau = c_tau*(cQ10_tau^((temp(i,j)-20)/10)); %CO2 compensation point
        %tau_2=tau_25*exp(0.07*(temp(i,j)-25));
        tau_2=tau_25*(exp(0.07*(temp(i,j)-25))); %Goudriaan page 165
        eff=c_epsilon(i,j)*((CO2(i,j)-tau_2)/(CO2(i,j)+(2*tau_2)));
        gaslaw=(44/24)*(298/(273+temp(i,j)))*1000;
        epsilon = c_epsilon(i,j)*(CO2(i,j)-tau_2)/(CO2(i,j)+(2*tau_2));%Light use efficiency 
        g_car=(c_car1*(temp(i,j)^2))+(c_car2*temp(i,j))+(c_car3);
        g_CO2_inv = (1/g_bnd)+(1/g_stm)+(1/g_car);
        g_CO2=1/g_CO2_inv;
        Fnc=((CO2(i,j)-tau_2)*gaslaw)/((Rm(i,1)+(1.6*(Rs+Rbv)))); %Units are in microg/m2-s
%         f_photmax= ((epsilon*(DailyPAR(i,j))*g_CO2*c_w*1e6*(CO2(i,j)-tau_2))...
%         /((epsilon*(DailyPAR(i,j)))+(g_CO2*c_w*1e6*(CO2(i,j)-tau_2))));
%         f_photmax=min(f_photmax,Fmm(i,1));
        f_photmax1=min(Fnc,Fmm(i,1));
%         f_photmax_record(i,j)=f_photmax; 
        f_photmax_record1(i,j)=f_photmax1; 
        if(i==1||i==745||i==1417||i==2161||i==2881||i==3625||i==4345||i==5089||...
            i==5833||i==6553||i==7297||i==8017)
        LAI_record(i,j)=c_lar_hour*(Xsdw(i,j)+Xnsdw(i,j));
        else
            LAI_record(i,j)=LAI_record(i-1,j)+(c_lar_hour*((Xsdw(i,j)+Xnsdw(i,j))-...
                (Xsdw(i-1,j)+Xnsdw(i-1,j))));
        end
        kdf=(0.178*exp(-1.93*LAI_record(i,j)))+(0.514*exp(-0.707*LAI_record(i,j)))+...
            (0.308*exp(-0.518*LAI_record(i,j)));
        kdf=-log(kdf);
        kdf=kdf/LAI_record(i,j);
        kdf_record(i,1)=kdf;
        %sig=0.2;
        refh=(1-sqrt(1-sig))/(1+sqrt(1-sig));
        %kbl=0.5;
        refs=(2*kbl/(kbl+kdf))*refh;
        PARdf=DailyPAR(i,j)*0.5;
        PARdr=DailyPAR(i,j)*0.5;
        wt(1,1)=0.1184635;
        wt(2,1)=0.2393144;
        wt(3,1)=0.2844444;
        wt(4,1)=0.2393144;
        wt(5,1)=0.1184635;
        dist(1,1)=0.0469101;
        dist(2,1)=0.2307534;
        dist(3,1)=0.5;
        dist(4,1)=0.7692465;
        dist(5,1)=0.9530899;
        laic=[LAI_record(i,j)*dist(1,1);LAI_record(i,j)*dist(2,1);LAI_record(i,j)*dist(3,1);...
            LAI_record(i,j)*dist(4,1);LAI_record(i,j)*dist(5,1)];
        Fgros=0;
        for p=1:5
        visdf=(1-refh)*PARdf*kdf*exp(-kdf*laic(p,1));
        vist=(1-refh)*PARdr*kbl*sqrt(1-sig)*exp(-kbl*sqrt(1-sig)*laic(p,1));
        visd=(1-sig)*PARdr*kbl*exp(-kbl*laic(p,1));
        visshd=visdf+vist-visd;
        vispp=(1-sig)*PARdr;
        vissun=(vispp*dist(p,1))+(visshd);
        fslla=exp(-kbl*laic(p,1));
        eI_fmax_shd=eff*visshd/f_photmax1;
        eI_fmax_sun=eff*vissun/f_photmax1;
        %theta=0.7;
        R_B_temp=R_B(i,j);
        
               if(R_B_temp==0)
    
    num_theta1=xlsread('theta.xlsx','R_B_0');
    temp_visshd=round(visshd);
    temp_vissun=round(vissun);
    theta1_shd=num_theta1(temp_visshd+1,1);

    theta_shd=theta1_shd;
    
    theta1_sun=num_theta1(temp_vissun+1,1);
   
    theta_sun=theta1_sun;
end


if(R_B_temp>=0&&R_B_temp<=1)
    
    temp_visshd=round(visshd);
    temp_vissun=round(vissun);
    theta1_shd=num_theta1(temp_visshd+1,1);
    theta2_shd=num_theta2(temp_visshd+1,1);
    theta_shd=theta1_shd+((((theta2_shd-theta1_shd)/1))*(R_B_temp));
    
    theta1_sun=num_theta1(temp_vissun+1,1);
    theta2_sun=num_theta2(temp_vissun+1,1);
    theta_sun=theta1_sun+((((theta2_sun-theta1_sun)/1))*(R_B_temp));
end

if(R_B_temp>1&&R_B_temp<=4)
    
    temp_visshd=round(visshd);
    temp_vissun=round(vissun);
    theta1_shd=num_theta2(temp_visshd+1,1);
    theta2_shd=num_theta3(temp_visshd+1,1);
    theta_shd=theta1_shd+((((theta2_shd-theta1_shd)/3))*(R_B_temp-1));
    
    theta1_sun=num_theta2(temp_vissun+1,1);
    theta2_sun=num_theta3(temp_vissun+1,1);
    theta_sun=theta1_sun+((((theta2_sun-theta1_sun)/3))*(R_B_temp-1));
end

if(R_B_temp>4&&R_B_temp<=8)
    
    temp_visshd=round(visshd);
    temp_vissun=round(vissun);
    theta1_shd=num_theta3(temp_visshd+1,1);
    theta2_shd=num_theta4(temp_visshd+1,1);
    theta_shd=theta1_shd+((((theta2_shd-theta1_shd)/4))*(R_B_temp-4));
    
    theta1_sun=num_theta3(temp_vissun+1,1);
    theta2_sun=num_theta4(temp_vissun+1,1);
    theta_sun=theta1_sun+((((theta2_sun-theta1_sun)/4))*(R_B_temp-4));
end

if(R_B_temp>8&&R_B_temp<=12)

    temp_visshd=round(visshd);
    temp_vissun=round(vissun);
    theta1_shd=num_theta5(temp_visshd+1,1);
    theta2_shd=num_theta6(temp_visshd+1,1);
    theta_shd=theta1_shd+((((theta2_shd-theta1_shd)/4))*(R_B_temp-8));
    
    theta1_sun=num_theta5(temp_vissun+1,1);
    theta2_sun=num_theta6(temp_vissun+1,1);
    theta_sun=theta1_sun+((((theta2_sun-theta1_sun)/4))*(R_B_temp-8));
end

if(R_B_temp>12)
    

    temp_visshd=round(visshd);
    temp_vissun=round(vissun);
    theta1_shd=num_theta6(temp_visshd+1,1);

    theta_shd=theta1_shd;
    
    theta1_sun=num_theta6(temp_vissun+1,1);
   
    theta_sun=theta1_sun;
end
        fact1_shd=1+eI_fmax_shd;
        fact1_sun=1+eI_fmax_sun;
        fact2_shd=4*eI_fmax_shd*theta_shd;
        fact2_sun=4*eI_fmax_sun*theta_sun;
        fact3_shd=sqrt((fact1_shd)^2-fact2_shd);
        fact3_sun=sqrt((fact1_sun)^2-fact2_sun);
        y_shd=(fact1_shd-fact3_shd)/(2*theta_shd);
        y_sun=(fact1_sun-fact3_sun)/(2*theta_sun);
        Fn_shd=y_shd*f_photmax1;
        Fn_sun=y_sun*f_photmax1;
        Fgros1=((fslla*Fn_sun)+((1-fslla)*Fn_shd))*wt(p,1);
        Fgros=Fgros+Fgros1;
        end
        Fphot=Fgros*LAI_record(i,j);
        temp1=((c_alpha*Fphot*1e-6*phi_ps2(i,j)*3600-(rgr*3600*Xsdw(i,j))-fresp*3600-...
        ((1-c_beta)/c_beta)*rgr*3600*Xsdw(i,j)));
        if(temp1>0)    
            Xnsdw(i+1,j)=Xnsdw(i,j)+temp1;
            Xsdw(i+1,j)=Xsdw(i,j)+(rgr*3600*Xsdw(i,j));
        else
            temp2=((c_alpha*Fphot*phi_ps2(i,j)*1e-6*3600-fresp*3600-...
            ((1-c_beta)/c_beta)*rgr*3600*Xsdw(i,j)));
            Xsdw(i+1,j)=Xsdw(i,j)+temp2;
            Xnsdw(i+1,j)=Xnsdw(i,j);
        end
            i=i+1;
    end
    Ydw(i,j) = (Xnsdw(i,j)+Xsdw(i,j))/plantingdensity; %Assuming plant density of 18. %Dry weight of plant(g)
    Ylai(i,j)= c_lar_hour*(Xsdw(i,j)+Xnsdw(i,j))/plantingdensity; %Assuming plant density of 18.
    %Leaf area of plant (m2 leaf/m2 ground)
end

Ydw(hourstotal+1,j) = (Xnsdw(hourstotal+1,j)+Xsdw(hourstotal+1,j))/plantingdensity; %Assuming plant density of 18.
Ylai(hourstotal+1,j)= c_lar_hour*(Xsdw(hourstotal+1,j)+Xnsdw(hourstotal+1,j))/plantingdensity; %Assuming plant density of 18.
end
cycle_harvest(12,:)=Ydw(8761,:);
%totalharvest=cycle_harvest(1,1)*plantingdensity;

%Similar to tomato_yield_calc file
for i=1:totalcases
    cycle_harvest(13,i)=sum(cycle_harvest(1:12,i));
end
totalharvest=cycle_harvest(13,:)*plantingdensity/1000; 
Qtotalheat_all=Qtotalheat_all*0.000293/1055.1;
Voltage=240;
current=25.3;
phasefactor=1;
rmsvalue=1.7;
heat_heater=34100;
for i=1:totalcases
    maxheat(i,1)=max(Qtotalheat_all(:,i))*length*width/0.000293;
    numberofheaters(i,1)=round(maxheat(i,1)/heat_heater);
    if(numberofheaters(i,1)<1)
        numberofheaters(i,1)=1;
    end
    totaldesignbtu(i,1)=numberofheaters(i,1)*heat_heater*0.000293/(length*width);
    hoursactive(:,i)=Qtotalheat_all(:,i)/totaldesignbtu(i,1);
    electricheat_all(:,i)=hoursactive(:,i)*rmsvalue*phasefactor*current*Voltage*numberofheaters(i,1);
end
electricheat_all=electricheat_all/(length*width*1000);
DailyPAR_daily=zeros(365,totalcases);  
cycle_monthly=zeros(12,totalcases);
for i=1:totalcases
cycle_monthly(1,i)=Ydw(744,i);
cycle_monthly(2,i)=Ydw(1416,i);
cycle_monthly(3,i)=Ydw(2160,i);
cycle_monthly(4,i)=Ydw(2880,i);
cycle_monthly(5,i)=Ydw(3624,i);
cycle_monthly(6,i)=Ydw(4344,i);
cycle_monthly(7,i)=Ydw(5088,i);
cycle_monthly(8,i)=Ydw(5832,i);
cycle_monthly(9,i)=Ydw(6552,i);
cycle_monthly(10,i)=Ydw(7296,i);
cycle_monthly(11,i)=Ydw(8016,i);
cycle_monthly(12,i)=Ydw(8760,i);
Qtotalheat_harvest(1,i)=sum(electricheat_all(1:744,i));
Qtotalheat_harvest(2,i)=sum(electricheat_all(745:1416,i));
Qtotalheat_harvest(3,i)=sum(electricheat_all(1417:2160,i));
Qtotalheat_harvest(4,i)=sum(electricheat_all(2161:2880,i));
Qtotalheat_harvest(5,i)=sum(electricheat_all(2881:3624,i));
Qtotalheat_harvest(6,i)=sum(electricheat_all(3625:4344,i));
Qtotalheat_harvest(7,i)=sum(electricheat_all(4345:5088,i));
Qtotalheat_harvest(8,i)=sum(electricheat_all(5089:5832,i));
Qtotalheat_harvest(9,i)=sum(electricheat_all(5833:6552,i));
Qtotalheat_harvest(10,i)=sum(electricheat_all(6553:7296,i));
Qtotalheat_harvest(11,i)=sum(electricheat_all(7297:8016,i));
Qtotalheat_harvest(12,i)=sum(electricheat_all(8017:8760,i));

Qtotalheat_monthly(1,i)=sum(electricheat_all(1:744,i));
Qtotalheat_monthly(2,i)=sum(electricheat_all(745:1416,i));
Qtotalheat_monthly(3,i)=sum(electricheat_all(1417:2160,i));
Qtotalheat_monthly(4,i)=sum(electricheat_all(2161:2880,i));
Qtotalheat_monthly(5,i)=sum(electricheat_all(2881:3624,i));
Qtotalheat_monthly(6,i)=sum(electricheat_all(3625:4344,i));
Qtotalheat_monthly(7,i)=sum(electricheat_all(4345:5088,i));
Qtotalheat_monthly(8,i)=sum(electricheat_all(5089:5880,i));
Qtotalheat_monthly(9,i)=sum(electricheat_all(5881:6552,i));
Qtotalheat_monthly(10,i)=sum(electricheat_all(6553:7296,i));
Qtotalheat_monthly(11,i)=sum(electricheat_all(7297:8016,i));
Qtotalheat_monthly(12,i)=sum(electricheat_all(8017:8760,i));


Ventilationpower_monthly(1,i)=sum(ventilation_powerhour_all(1:744,i));
Ventilationpower_monthly(2,i)=sum(ventilation_powerhour_all(745:1416,i));
Ventilationpower_monthly(3,i)=sum(ventilation_powerhour_all(1417:2160,i));
Ventilationpower_monthly(4,i)=sum(ventilation_powerhour_all(2161:2880,i));
Ventilationpower_monthly(5,i)=sum(ventilation_powerhour_all(2881:3624,i));
Ventilationpower_monthly(6,i)=sum(ventilation_powerhour_all(3625:4344,i));
Ventilationpower_monthly(7,i)=sum(ventilation_powerhour_all(4345:5088,i));
Ventilationpower_monthly(8,i)=sum(ventilation_powerhour_all(5089:5832,i));
Ventilationpower_monthly(9,i)=sum(ventilation_powerhour_all(5833:6552,i));
Ventilationpower_monthly(10,i)=sum(ventilation_powerhour_all(6553:7296,i));
Ventilationpower_monthly(11,i)=sum(ventilation_powerhour_all(7297:8016,i));
Ventilationpower_monthly(12,i)=sum(ventilation_powerhour_all(8017:8760,i));


Powertotal_monthly(1,i)=sum(Powertotal_all(1:744,i));
Powertotal_monthly(2,i)=sum(Powertotal_all(841:1416,i));
Powertotal_monthly(3,i)=sum(Powertotal_all(1417:2160,i));
Powertotal_monthly(4,i)=sum(Powertotal_all(2161:2880,i));
Powertotal_monthly(5,i)=sum(Powertotal_all(2881:3624,i));
Powertotal_monthly(6,i)=sum(Powertotal_all(3625:4344,i));
Powertotal_monthly(7,i)=sum(Powertotal_all(4345:5088,i));
Powertotal_monthly(8,i)=sum(Powertotal_all(5089:5832,i));
Powertotal_monthly(9,i)=sum(Powertotal_all(5833:6552,i));
Powertotal_monthly(10,i)=sum(Powertotal_all(6553:7296,i));
Powertotal_monthly(11,i)=sum(Powertotal_all(7297:8016,i));
Powertotal_monthly(12,i)=sum(Powertotal_all(8017:8760,i));

Powertotal_monthly(:,i)=Powertotal_monthly(:,i)/(length*width);
Annualpowertotal(1,i)=sum(Powertotal_monthly(:,i));

for k=1:365
    for j=(k*24)-23:(k*24)
        if(i==35)
            a=1;
        end
        DailyPAR_daily(k,i)=DailyPAR_daily(k,i)+DailyPAR(j,i);
    end
    
end
DailyPAR_daily(:,i)=DailyPAR_daily(:,i)/1000;
DailyPAR_daily_moles=DailyPAR_daily*4.54*1000*3600*1e-6;
DailyPAR_daily_moles_monthly(1,i)=sum(DailyPAR_daily_moles(1:31,i))/31;
DailyPAR_daily_moles_monthly(2,i)=sum(DailyPAR_daily_moles(32:59,i))/28;
DailyPAR_daily_moles_monthly(3,i)=sum(DailyPAR_daily_moles(60:90,i))/31;
DailyPAR_daily_moles_monthly(4,i)=sum(DailyPAR_daily_moles(91:120,i))/30;
DailyPAR_daily_moles_monthly(5,i)=sum(DailyPAR_daily_moles(121:151,i))/31;
DailyPAR_daily_moles_monthly(6,i)=sum(DailyPAR_daily_moles(152:181,i))/30;
DailyPAR_daily_moles_monthly(7,i)=sum(DailyPAR_daily_moles(182:212,i))/31;
DailyPAR_daily_moles_monthly(8,i)=sum(DailyPAR_daily_moles(213:243,i))/31;
DailyPAR_daily_moles_monthly(9,i)=sum(DailyPAR_daily_moles(244:273,i))/30;
DailyPAR_daily_moles_monthly(10,i)=sum(DailyPAR_daily_moles(274:304,i))/31;
DailyPAR_daily_moles_monthly(11,i)=sum(DailyPAR_daily_moles(305:334,i))/30;
DailyPAR_daily_moles_monthly(12,i)=sum(DailyPAR_daily_moles(335:365,i))/31;
AnnualPAR(1,i)=sum(DailyPAR_daily(:,i));
Annualheat(1,i)=sum(Qtotalheat_harvest(:,i));
Annualventilation(1,i)=sum(Ventilationpower_monthly(:,i));
end
Annualventilation=Annualventilation/(29.2608*7.3152);
Ventilationpower_monthly=Ventilationpower_monthly/(29.2608*7.3152);
cycle_monthly_harvest=cycle_monthly/0.05; %Converting dry weight to FW
totalharvest_fw=totalharvest/(0.05); 
totalharvest_fw1=totalharvest_fw';
 Annualpowertotal1=Annualpowertotal';
for i=1:totalcases
    PCE_harvest(i,1)=PCEernet_all(i,1)/totalharvest_fw1(i,1);
end

YC=totalharvest_fw1;
    energydemand=Annualheat+Annualventilation; %Total energy demand (kWh/m2-year)
    energydemand=energydemand';
    surplus=-energydemand+Annualpowertotal1;
    Annualsurplus=surplus; %Net greenhouse energy offset (kWh/m2-year)
  
  %Levilized cost of electricity for select climates
  LCOE_loc=[0.13;0.16;0.11;0.15;0.12;0.1;0.12;0.11;0.1;0.12;0.2;0.12;0.16;0.14;...
    0.12;0.1;0.16;0.12;0.11;0.22;0.12;0.1;0.13;0.15;0.11];

for j=1:1 %%size of str2
LCOE(:,j)=LCOE_loc(j,1)*ones(1,1); %size of str1*str2.
end
OPV_u=0.77;
TOPV=10;
Annualheating_AN=Annualheat(:,1);
Annualheating_matrix=Annualheating_AN;

Annualventilation_AN=Annualventilation(:,1);
Annualventilation_matrix=Annualventilation_AN;
Annualelectricenergy_matrix=Annualventilation_matrix;
Annualenergydemand1_matrix=Annualheating_matrix+Annualventilation_matrix;  
Annualsolarpower_AN=Powertotal_all;
Annualsolarpower_matrix=Annualsolarpower_AN;
Annualsurplus_matrix1=Annualsolarpower_matrix-Annualenergydemand1_matrix;

Annualsurplus_AN=Annualsurplus_matrix1(:,1);
 

totalannualyield_AN=totalharvest_fw1(:,1);

 
DE=Annualenergydemand1_matrix*length*width;
CE=0.16; %Cost of electricity ($/kWh)
Cmeter=0.0; %Cost of metering ($/kWh)
CH=7.55; %Cost of heating ($/kWh)
CL=17000; %Cost of land ($/acre)
YC=totalannualyield_AN; %yield (kg/m2-year).
p=1;
for i=1:1 %%size of str1
    for j=1:1 %%size of str2
        for k=1:1 %%size of str3
            PCEernet_matrix(k,j)=PCEernet_all(p,1);
            p=p+1;
        end
    end
end

%PCEernet_matrix(321,:)=0; % sconventional greenhouse

 PCE_AN=PCEernet_matrix(:,1);

PCE_matrix=PCE_AN;
pcov_AN=pcov_all;
pcov_matrix=pcov_AN;

 
CALH=25; %Cost of greenhouse structure ($/ft2)
VM=4.4; %market value of vegetation ($/kg) 
DP=length*width; %Area of ground (m2)
COM=2.3; %Cost of labor ($/ft2)
AGH=29.2608*7.3152; %Area of greenhouse (m2)
tGH=30; %Lifetime of greenhouse (years)
discountrate=0.1; %Discount rate
CRFOPV=(discountrate*(1+discountrate)^TOPV)/((1+discountrate)^TOPV-1);
%Capital recovery factor for OPV
CRFGH=(discountrate*(1+discountrate)^tGH)/((1+discountrate)^tGH-1);
%Capital recovery factor for greenhouse
   IA=VM*YC*DP; %Total selling price ($) 
   for i=1:1 %% size of str1*str3
     for j=1:1  %% size of str2
   if(i<=320) %%size of str1*str2
    PL(i,j)=(Annualsolarpower_matrix(i,j)*(AGH)*LCOE(i,j)*CRFOPV*10/...
       (PCE_matrix(i,j)/pcov_matrix(i,j)))+(CL*CRFGH*AGH*0.00025)+...
       (CALH*AGH*CRFGH*10.7639); %Annualized investment cost ($)
   
          
       
 %      end
   else %%conventional greenhouse
           
       PL(i,j)=(CL*CRFGH*AGH*0.00025)+(CALH*AGH*CRFGH*10.7639);

   end

   %end
     end
   end
   for i=1:1 %%size of str1*str3
       for j=1:1 %%size of str2
           NPV_matrix(i,j)=0; %Net present value
           if(i<=320) %%size of str1*str2
               if(Annualsurplus_matrix1(i,j)>0)
                CV=(-Annualsurplus_matrix1(i,j)*AGH*Cmeter);
                RT=IA(i,j)-PL(i,j)-CV;
                for k=1:30           
                    NPV_matrix(i,j)=NPV_matrix(i,j)+(RT/((1+discountrate)^k));
                end
           
               else        

                for k=1:30 %%greenhouse lifetime
               
               
                CV=(CH*((1.01)^(k-1))*(-Annualsurplus_matrix1(i,j))*...
               AGH/293.07);
                RT=IA(i,j)-PL(i,j)-CV;
       
                    NPV_matrix(i,j)=NPV_matrix(i,j)+(RT/((1+discountrate)^k));

                end
                 
           
               end
           else %%conventional greenhouse
                      
       for k=1:30
       CV=((CE*Annualelectricenergy_matrix(i,j)*AGH)+(CH*Annualheating_matrix(i,j)*AGH/293.07))*((1.01)^(k-1));
       RT=IA(i,j)-PL(i,j)-CV;
                        
       NPV_matrix(i,j)=NPV_matrix(i,j)+(RT/((1+discountrate)^k));
                

       end
           end
       end
   end

NPV_AN=NPV_matrix(:,1);
save 'energy_lettuce_NPV.mat'




