clear all 
close all
clc
%% Processing all energy, light results from different solar cells and computing tomato yield
%% Input parameters
% This is a sample file processing information for PTB7-Th:IEICO4F
% greenhouse for Anchorage, Alaska as location for 100 % OPV coverage
Anwins_cond=1; %North facing wall of greenhouse is insulated.
length=29.2608; %Length of greenhouse (m)
width=7.3152; %Width of greenhouse (m)
k=1;
totalcases1=1; %Total number of cases considered. Can be changed as needed. 
fracPAR_wall=zeros(8760,totalcases1); %fraction of PAR light intensity entering through the walls
pcov_all=zeros(totalcases1,1); %Roof coverage area of solar cells

% str1 represents list of all used solar cells
% str1=["PBDBT_CPDT4F";"PBDBT_CPDT4Cl";"D18_Y6";"PBDBT_ITIC";"J60_ITIC";"J61_ITIC";...
%     "J71_ITIC";"PTzBIDT_ITIC";"PBQ4F_ITIC";"PBZ_m_CF3_ITIC";"PBDT_S_2TC_ITIC";...
%     "PTzBI_ITIC";"PBPDTh_ITIC";"PTBFBZ_ITIC";"PDCBT_ITIC";"asy_PBDBTN_ITIC";...
%     "PTBTz2_ITIC";"HD_PBDT2FT_ITIC";"HFQx_T_ITIC";"PBTCl_ITIC";"PM6_ITIC";...
%     "PaNBDT_T1_ITIC";"PBDTTzBP_ITIC";"PBDTTZN_ITIC";"PBDTS_NQx_ITIC";"PBDTSF_FBT_ITIC";...
%     "PBDTS_TDZ_ITIC"; "3MTB_ITIC";"PDRCNBDT_ITIC";"PDTP4TFBT_ITIC";"PBDTsThPh_BDD_ITIC";"3MT-Th_ITIC";...
%     "PTzBITh_ITIC";"PBDBT_ITM";"PBDTBDD_ITICM"; "PDCBT2F_ITM";"PBDBT_IDTHN";...
%     "PBDBT_ITOM2";"PBTIBDTTS_ITICF";"PBDBTSF_IT4F";"PBDBTF_IT4F";"DRTBTC2_IT4F";...
%     "PM7_IT4F";"PDTBEFT_IT4F";"PBDBTF_IT2F_IT4F";"PBDBTF_IDTN";"PB3T_ITM";"FTAZ_INIC3";...
%     "PM6_IT4F";"PffBT4T_SFPDI2";"PTzBI_N2200";"PTB7TH_ITICTh";"PDBTT1_ITICTh";"PCE10_IDTBR_IDFBR";...
%     "PTB7TH_ITIC";"PTB7TH_CTIC4F";"PTB7TH_CO14F";"PTB7TH_COTIC4F";"PBDBT2F_IT4Cl";...
%     "PM6_Y6";"DPP2T_IEICO4F";"FTAZ_IEICO4F_PCBM";"PTB7TH_IEICO4F";"FTAZ_ITM"];

str1="PTB7TH_IEICO4F";

%str2 represents list of all used climates/locations
% str2=["SI";"CHI";"MI";"CH";"SAO";"EL";"JO";"DE";...
%     "LO";"UN";"GU";"JOH";"SE";"LE";"PY";"CAL";"YU";...
%     "SA";"SO";"AN";"MO";"AZ";"NC";"WI";"CA"];
str2="AN";

%str3 represents different roof coverage ratio percentages
%str3=["100";"80";"60";"40";"20"];
str3="100";
str4='.mat';
% str6='conv';
%absorption edge of all active layers selected
% absorptionedge_matrix=[910;910;910;750;750;750;750;750;750;750;750;750;750;750;750;...
%     750;750;750;750;750;750;750;750;750;750;750;750;750;750;750;750;750;750;740;740;...
%     740;660;740;770;760;760;760;760;760;760;750;740;780;760;730;780;740;740;750;...
%     740;910;1020;1120;790;870;950;950;950;740];
absorptionedge_matrix=950;
%band gap of all active layers selected
% bandgap_matrix=[1.31;1.25;1.41;1.31;1.51;1.51;1.51;1.61;1.56;1.64;1.63;1.56;1.57;...
%     1.61;1.33;1.48;1.51;1.51;1.62;1.71;1.65;1.62;1.42;1.4;1.48;1.58;1.56;1.31;...
%     1.34;1.48;1.56;1.31;1.41;1.35;1.35;1.62;1.47;1.47;1.44;1.26;1.26;1.37;1.45;1.37;...
%     1.54;1.5;1.43;1.5;1.4;1.53;1.5;1.27;1.43;1.54;1.4;1.2;1.1;1.1;1.38;1.4;0.91;1.14;...
%     1.05;1.38];
bandgap_matrix=1.05;
%absorption edge of donor organic semiconductor in the selected active
%layer.
% absorptionedge_donor_matrix=[650;650;625;650;620;590;610;615;540;600;570;...
%     750;630;640;620;650;760;600;700;680;665;600;620;615;570;700;580;630;660;710;...
%     640;570;650;650;650;585;650;650;655;650;650;605;670;615;650;650;640;600;665;...
%     730;650;745;660;750;745;745;745;745;650;660;850;600;745;600];
absorptionedge_donor_matrix=745;
CO2=450; %Available CO2 to plants
p=1;
for i=1:1 %adjust to size of str1
    for j=1:1 %adjust to size of str2
        for k=1:1 %adjust to size of str3
            str5(p,:)=strcat(str1(i,:),'_',str2(j,:),'_',str3(k,:),str4);
            load(str5(p,:),'pcov','lightinput_wm2',...
            'th','T','Qtotalheat','ventilation_powerhour','Pouter','Poutwr','Pouterd',...
            'Poutwrd','Ac','Netenergywall','PCEernet','electricenergy_lamps',...
            'Annualelectricenergy_lamp','monthlyelectricenergy_lamp','DLI_inside','sunrise','sunset');
            %[num,text,raw]=xlsread('Lettuceliterature_data.xlsx','phytotron_control');             
            DLI_inside_all(:,p)=DLI_inside; %daylight integral reaching plants (moles m-2 day-1)
            sunrise_all(:,p)=sunrise; %Time of sunrise (hours)
            sunset_all(:,p)=sunset; %Time of sunset (hours)
            [Wmatrix_combined_all(:,p),WFmatrix_combined_all(:,p),LAImatrix_combined_all(:,p)] = ...
                tomato(DLI_inside,th,sunrise,sunset,CO2); %Function file computing tomato yield
            pcov_all(p,1)=pcov; %Roof coverage percentage for organic solar cells
            absorptionedge(p,1)=absorptionedge_matrix(i,1); %absorption edge of active layers
            bandgap(p,1)=bandgap_matrix(i,1); %bandgap of active layers
            absorptionedge_donor(p,1)=absorptionedge_donor_matrix(i,1); %absorption edge of donor in active layer
            DailyPAR(:,p)=lightinput_wm2; %hourly PAR light intensity (W/m2)
            PCEernet_all(p,1)=max(PCEernet(:,1)); %Hourly efficiency of semitransparent organic solar cells (%)
            electricenergy_lamps_all(:,p)=electricenergy_lamps; %electric energy consumed by supplemental lighting
            %kWh/m2-hour
            Annualelectricenergy_lamp_all(p,1)=Annualelectricenergy_lamp; %Annual electric energy consumed by 
            %supplemental lighting (kWh/m2-year)
            monthlyelectricenergy_lamp_all(:,p)=monthlyelectricenergy_lamp; %Annual electric energy consumed by 
            %supplemental lighting (kWh/m2-month)
            lightinputyear_plants_wall_wm2=0.5*0.75*(Netenergywall*0.432)/(length*width); 
            %hourly PAR light available to plants from wall (W/m2)
            for t=1:8760 
                if(lightinputyear_plants_wall_wm2(t,1)>0)
                    fracPAR_wall(t,p)=lightinputyear_plants_wall_wm2(t,1)/lightinput_wm2(t,1);

                end
            end

            temp(:,p)=th(:,3); %hourly greenhouse air temperature (C)      
            T_all(:,p)=T(:,1); %Transmittance spectra of organic solar cells
            Qtotalheat_all(:,p)=Qtotalheat(:,1); %hourly heating energy demand (J/m2-hr)
            ventilation_powerhour_all(:,p)=ventilation_powerhour(:,1); %hourly ventilation energy demand (J/m2-hr)
            for t=1:8760
            Powertotal(t,1)=(((Pouter(t,1)+Poutwr(t,1))*(Ac/2))+((Pouterd(t,1)+Poutwrd(t,1))*(Ac/2)))/1000;
            
            end
            Powertotal_all(:,p)=Powertotal(:,1)*0.85; %Houly total power generated from solar cell (kWh/m2-hour)
            p=p+1;
        end
    end
end
%% conventional greenhouse
%we don't consider a conventional greenhouse case here
% for i=1:25
% str5(p,:)=strcat(str6,'_',str2(i,:),str4);
% pcov_all(p,1)=0;
% absorptionedge(p,1)=1200; %dummy values
% bandgap(p,1)=2;
% absorptionedge_donor(p,1)=1000; %dummy values
% % conv k=1281:1284
% load(str5(p,:),'lightinput_wm2',...
%     'th','T','Qtotalheat','ventilation_powerhour','Pouter','Poutwr','Pouterd','Poutwrd','Ac',...
%     'Netenergywall','PCEernet','electricenergy_lamps',...
%             'Annualelectricenergy_lamp','monthlyelectricenergy_lamp','DLI_inside','sunrise','sunset');
% DLI_inside_all(:,p)=DLI_inside;
% sunrise_all(:,p)=sunrise;
% sunset_all(:,p)=sunset;
% [Wmatrix_combined_all(:,p),WFmatrix_combined_all(:,p),LAImatrix_combined_all(:,p)] = tomato(DLI_inside,th,sunrise,sunset,CO2);
% DailyPAR(:,p)=lightinput_wm2;
% PCEernet_all(p,1)=max(PCEernet(:,1));
% lightinputyear_plants_wall_wm2=0.5*0.75*(Netenergywall*0.432)/(length*width);
% for t=1:8760
%     if(lightinputyear_plants_wall_wm2(t,1)>0)
%         fracPAR_wall(t,p)=lightinputyear_plants_wall_wm2(t,1)/lightinput_wm2(t,1);
% 
%     end
% end
% electricenergy_lamps_all(:,p)=electricenergy_lamps;
% Annualelectricenergy_lamp_all(p,1)=Annualelectricenergy_lamp;
% monthlyelectricenergy_lamp_all(:,p)=monthlyelectricenergy_lamp;
% temp(:,p)=th(:,3);
% T_all(:,p)=T(:,1);
% Qtotalheat_all(:,p)=Qtotalheat(:,1);
% ventilation_powerhour_all(:,p)=ventilation_powerhour(:,1);
% for t=1:8760
% Powertotal(t,1)=(((Pouter(t,1)+Poutwr(t,1))*(Ac/2))+((Pouterd(t,1)+Poutwrd(t,1))*(Ac/2)))/1000;
% end
% Powertotal_all(:,p)=Powertotal(:,1)*0.85;
% p=p+1
% end

Qtotalheat_matrix=Qtotalheat_all*0.000293/1055.1; %Converting heating energy demand to kWh/m2-hour
Voltage=240; %Heater voltage (V)
current=25.3; %Heater current (A)
phasefactor=1; %Heater phase factor
rmsvalue=1.7; %Heater RMS value
heat_heater=34100; %Heat provided by each heater (BTU)
for i=1:totalcases1
    maxheat(i,1)=max(Qtotalheat_matrix(:,i))*length*width/0.000293; %maximum heating demand (BTU)
    numberofheaters(i,1)=round(maxheat(i,1)/heat_heater); %number of heaters requried
    if(numberofheaters(i,1)<1)
        numberofheaters(i,1)=1;
    end
    totaldesignbtu(i,1)=numberofheaters(i,1)*heat_heater*0.000293/(length*width); %Design heating energy for
    %heaters (kWh/m2)
    hoursactive(:,i)=Qtotalheat_matrix(:,i)/totaldesignbtu(i,1); %hours the heater is active
    electricheat_all(:,i)=hoursactive(:,i)*rmsvalue*phasefactor*current*Voltage*numberofheaters(i,1);
    %Electric heating energy demand (kWh)
end
electricheat_all=electricheat_all/(length*width*1000); %Electric heating energy demand (kWh/m2-hour)

for i=1:totalcases1
    %Monthly heating energy demand (kWh/m2-month)
    Qtotalheat_harvest(1,i)=sum(electricheat_all(1:744,i));
    Qtotalheat_harvest(2,i)=sum(electricheat_all(745:1416,i));
    Qtotalheat_harvest(3,i)=sum(electricheat_all(1417:2160,i));
    Qtotalheat_harvest(4,i)=sum(electricheat_all(2161:2880,i));
    Qtotalheat_harvest(5,i)=sum(electricheat_all(2881:3624,i));
    Qtotalheat_harvest(6,i)=sum(electricheat_all(3625:4344,i));
    Qtotalheat_harvest(7,i)=sum(electricheat_all(4345:5088,i));
    Qtotalheat_harvest(8,i)=sum(electricheat_all(5089:5832,i));
    Qtotalheat_harvest(9,i)=sum(electricheat_all(5833:6552,i));
    Qtotalheat_harvest(10,i)=sum(electricheat_all(6553:7296,i));
    Qtotalheat_harvest(11,i)=sum(electricheat_all(7297:8016,i));
    Qtotalheat_harvest(12,i)=sum(electricheat_all(8017:8760,i));


    %Monthly ventilation energy demand (kWh/month)
    Ventilationpower_monthly(1,i)=sum(ventilation_powerhour_all(1:744,i));
    Ventilationpower_monthly(2,i)=sum(ventilation_powerhour_all(745:1416,i));
    Ventilationpower_monthly(3,i)=sum(ventilation_powerhour_all(1417:2160,i));
    Ventilationpower_monthly(4,i)=sum(ventilation_powerhour_all(2161:2880,i));
    Ventilationpower_monthly(5,i)=sum(ventilation_powerhour_all(2881:3624,i));
    Ventilationpower_monthly(6,i)=sum(ventilation_powerhour_all(3625:4344,i));
    Ventilationpower_monthly(7,i)=sum(ventilation_powerhour_all(4345:5088,i));
    Ventilationpower_monthly(8,i)=sum(ventilation_powerhour_all(5089:5832,i));
    Ventilationpower_monthly(9,i)=sum(ventilation_powerhour_all(5833:6552,i));
    Ventilationpower_monthly(10,i)=sum(ventilation_powerhour_all(6553:7296,i));
    Ventilationpower_monthly(11,i)=sum(ventilation_powerhour_all(7297:8016,i));
    Ventilationpower_monthly(12,i)=sum(ventilation_powerhour_all(8017:8760,i));


    %Monthly power generated (kWh)
    Powertotal_monthly(1,i)=sum(Powertotal_all(1:744,i));
    Powertotal_monthly(2,i)=sum(Powertotal_all(841:1416,i));
    Powertotal_monthly(3,i)=sum(Powertotal_all(1417:2160,i));
    Powertotal_monthly(4,i)=sum(Powertotal_all(2161:2880,i));
    Powertotal_monthly(5,i)=sum(Powertotal_all(2881:3624,i));
    Powertotal_monthly(6,i)=sum(Powertotal_all(3625:4344,i));
    Powertotal_monthly(7,i)=sum(Powertotal_all(4345:5088,i));
    Powertotal_monthly(8,i)=sum(Powertotal_all(5089:5832,i));
    Powertotal_monthly(9,i)=sum(Powertotal_all(5833:6552,i));
    Powertotal_monthly(10,i)=sum(Powertotal_all(6553:7296,i));
    Powertotal_monthly(11,i)=sum(Powertotal_all(7297:8016,i));
    Powertotal_monthly(12,i)=sum(Powertotal_all(8017:8760,i));
    %Monthly power generated per unit area (kWh/m2-month)
    Powertotal_monthly(:,i)=Powertotal_monthly(:,i)/(length*width);
    
    %Annual power generated per unit area (kWh/m2-year)
    Annualpowertotal(1,i)=sum(Powertotal_monthly(:,i));
    %Annual heating demand per unit area (kWh/m2-year)
    Annualheat(1,i)=sum(Qtotalheat_harvest(:,i));
    Annualventilation(1,i)=sum(Ventilationpower_monthly(:,i));
end
    Annualventilation=Annualventilation/(29.2608*7.3152); %Annual ventilation energy per unit area (kWh/m2-year)
    Annualventilation1=Annualventilation';
    Annualheat1=Annualheat'; %Annual heating energy per unit area (kWh/m2-year)
    Annualpowertotal1=Annualpowertotal';
    Ventilationpower_monthly=Ventilationpower_monthly/(29.2608*7.3152); %Monthly ventilation energy per unit area
    %(kWh/m2-year)
    WFmatrix_combined_all_fw=WFmatrix_combined_all/(1000*0.04); %Fresh weight of fruit (kg/m2)
    for i=1:totalcases1
        totalannualfruitweight(i,1)=WFmatrix_combined_all_fw(179,i)+WFmatrix_combined_all_fw(365,i);
        %Fresh weight of fruit (kg/m2-year)
    end
    energydemand=Annualheat+Annualventilation+Annualelectricenergy_lamp_all'; %Total energy demand (kWh/m2-year)
    energydemand=energydemand';
    surplus=-energydemand+Annualpowertotal1;
    Annualsurplus=surplus; %Net greenhouse energy offset (kWh/m2-year)
  
  %Levilized cost of electricity for select climates
%   LCOE_loc=[0.13;0.16;0.11;0.15;0.12;0.1;0.12;0.11;0.1;0.12;0.2;0.12;0.16;0.14;...
%     0.12;0.1;0.16;0.12;0.11;0.22;0.12;0.1;0.13;0.15;0.11];
  LCOE_loc=0.13;

for j=1:1 %size of str2
LCOE(:,j)=LCOE_loc(j,1)*ones(1,1); %size of str1*str3
end
%LCOE(321,:)=0; %conventional greenhouse
OPV_u=0.77;
TOPV=10;

Annualheating_AN=Annualheat1(:,1);
Annualheating_matrix=Annualheating_AN;

Annualventilation_AN=Annualventilation1(:,1);
Annualventilation_matrix=Annualventilation_AN;
Annualelectricenergy_lamp_AN=Annualelectricenergy_lamp_all(:,1);
Annualelectricenergy_lamp_matrix=Annualelectricenergy_lamp_AN;
Annualelectricenergy_matrix=Annualventilation_matrix+...
    Annualelectricenergy_lamp_matrix;
Annualenergydemand1_matrix=Annualheating_matrix+Annualventilation_matrix+...
  Annualelectricenergy_lamp_matrix;  
Annualsolarpower_AN=Powertotal_all;
Annualsolarpower_matrix=Annualsolarpower_AN;
Annualsurplus_matrix1=Annualsolarpower_matrix-Annualenergydemand1_matrix;

Annualsurplus_AN=Annualsurplus_matrix1(:,1);
 

totalannualfruitweight_AN=totalannualfruitweight(:,1);

 
DE=Annualenergydemand1_matrix*length*width;
CE=0.16; %Cost of electricity ($/kWh)
Cmeter=0.0; %Cost of metering ($/kWh)
CH=7.55; %Cost of heating ($/kWh)
CL=17000; %Cost of land ($/acre)
YC=totalannualfruitweight_AN; %yield (kg/m2-year).
p=1;
for i=1:1 %%size of str1
    for j=1:1 %%size of str2
        for k=1:1 %%size of str3
            PCEernet_matrix(k,j)=PCEernet_all(p,1);
            p=p+1;
        end
    end
end

%PCEernet_matrix(321,:)=0; % sconventional greenhouse

 PCE_AN=PCEernet_matrix(:,1);

PCE_matrix=PCE_AN;
pcov_AN=pcov_all;
pcov_matrix=pcov_AN;

 
CALH=25; %Cost of greenhouse structure ($/ft2)
VM=4.4; %market value of vegetation ($/kg) 
DP=length*width; %Area of ground (m2)
COM=2.3; %Cost of labor ($/ft2)
AGH=29.2608*7.3152; %Area of greenhouse (m2)
tGH=30; %Lifetime of greenhouse (years)
discountrate=0.1; %Discount rate
CRFOPV=(discountrate*(1+discountrate)^TOPV)/((1+discountrate)^TOPV-1);
%Capital recovery factor for OPV
CRFGH=(discountrate*(1+discountrate)^tGH)/((1+discountrate)^tGH-1);
%Capital recovery factor for greenhouse
   IA=VM*YC*DP; %Total selling price ($) 
   for i=1:1 %% size of str1*str3
     for j=1:1  %% size of str2
   if(i<=320) %%size of str1*str2
    PL(i,j)=(Annualsolarpower_matrix(i,j)*(AGH)*LCOE(i,j)*CRFOPV*10/...
       (PCE_matrix(i,j)/pcov_matrix(i,j)))+(CL*CRFGH*AGH*0.00025)+...
       (CALH*AGH*CRFGH*10.7639); %Annualized investment cost ($)
   
          
       
 %      end
   else %%conventional greenhouse
           
       PL(i,j)=(CL*CRFGH*AGH*0.00025)+(CALH*AGH*CRFGH*10.7639);

   end

   %end
     end
   end
   for i=1:1 %%size of str1*str3
       for j=1:1 %%size of str2
           NPV_matrix(i,j)=0; %Net present value
           if(i<=320) %%size of str1*str2
               if(Annualsurplus_matrix1(i,j)>0)
                CV=(-Annualsurplus_matrix1(i,j)*AGH*Cmeter);
                RT=IA(i,j)-PL(i,j)-CV;
                for k=1:30           
                    NPV_matrix(i,j)=NPV_matrix(i,j)+(RT/((1+discountrate)^k));
                end
           
               else        

                for k=1:30 %%greenhouse lifetime
               
               
                CV=(CH*((1.01)^(k-1))*(-Annualsurplus_matrix1(i,j))*...
               AGH/293.07);
                RT=IA(i,j)-PL(i,j)-CV;
       
                    NPV_matrix(i,j)=NPV_matrix(i,j)+(RT/((1+discountrate)^k));

                end
                 
           
               end
           else %%conventional greenhouse
                      
       for k=1:30
       CV=((CE*Annualelectricenergy_matrix(i,j)*AGH)+(CH*Annualheating_matrix(i,j)*AGH/293.07))*((1.01)^(k-1));
       RT=IA(i,j)-PL(i,j)-CV;
                        
       NPV_matrix(i,j)=NPV_matrix(i,j)+(RT/((1+discountrate)^k));
                

       end
           end
       end
   end

NPV_AN=NPV_matrix(:,1);
save 'energy_tomato_NPV.mat'