function [R,T] = optics_glass(nglass,TotalNumberLayers,M,t)
%Parameters have the same meaning as defined in the optics function file
 T=zeros(M,90);
 R=zeros(M,90);
 lambda_s = 5*(1:M) + 295;       
 lambda_sm = (lambda_s)*10^-9;  
%Loop over wavelength
for bb = 1:M 
    lambda = lambda_sm(bb); 
    n0 = 1;         
    n(1) = nglass(bb);
    n(2) = 1;
    n(3)=1;
    n(4)=1;
    nn=zeros(TotalNumberLayers+1,1);
    k=zeros(TotalNumberLayers+1,1);
    for g = 1:TotalNumberLayers+1
        nn(g) = real(n(g));
        k(g) = imag(n(g));
    end
    angle=zeros(90,1);
    %Loop over angle
    for j = 1:90
        phi0 = (j-1)*pi/180; 
        angle(j,1) = (phi0*180)/pi;
        q0 = n0*cos(phi0); 
        q=zeros(TotalNumberLayers+1,1);
        eta=zeros(TotalNumberLayers+1,1);
        L=zeros(2,2,TotalNumberLayers);
        for g = 1:TotalNumberLayers
            q(g,1) = ((n(g))^2 - ((n0)^2*(sin(phi0))^2))^0.5; 
            eta(g,1) = ((2*pi)/(lambda))*q(g,1); 
            L(:,:,g) = [(exp(-1i*eta(g,1)*t(g))),(0);(0),(exp(1i*eta(g,1)*t(g)))]; 
        end
        q(g+1,1) = ((n(g+1))^2 - ((n0)^2*(sin(phi0))^2))^0.5;
        eta(g+1,1) = ((2*pi)/(lambda))*q(g+1,1);           
        phi(1,1) = asin(sin(phi0)*n0/n(1));
        for g=2:TotalNumberLayers+1
            phi(g,1) = asin(sin(phi(g-1,1))*n(g-1)/n(g)); 
        end     
        rp=zeros(1,TotalNumberLayers+1);
        rs=zeros(1,TotalNumberLayers+1);
        tp=zeros(1,TotalNumberLayers+1);
        ts=zeros(1,TotalNumberLayers+1);
        rp(1) = (((n(1))*cos(phi0)) - ((n0)*cos(phi(1,1))))/(((n(1))*cos(phi0)) +...
            ((n0)*cos(phi(1,1)))); 
        rs(1) = ((q0 - q(1,1))/(q0 + q(1,1)));
        tp(1) = (2*q0)/((n(1)*cos(phi0)) + ((n0)*cos(phi(1,1)))); 
        ts(1) = ((2*q0)/(q0 + q(1,1)));
        for g = 2:TotalNumberLayers+1             
            rp(g) = (((n(g))*cos(phi(g-1,1))) - ((n(g-1))*cos(phi(g,1))))/(((n(g))*...
                cos(phi(g-1,1))) + ((n(g-1))*cos(phi(g,1)))); 
            rs(g) = ((q(g-1,1) - q(g,1))/(q(g-1,1) + q(g,1)));
            tp(g) = (2*q(g-1,1))/((n(g)*cos(phi(g-1,1))) +...
                ((n(g-1))*cos(phi(g,1)))); 
            ts(g) = ((2*q(g-1,1))/(q(g-1,1) + q(g,1)));
        end
        Ip=zeros(2,2,TotalNumberLayers+1);
        Is=zeros(2,2,TotalNumberLayers+1); 
        for g = 1:TotalNumberLayers+1
            Ip(:,:,g) = [(1/tp(g)),(rp(g)/tp(g));(rp(g)/tp(g)),(1/tp(g))]; 
            Is(:,:,g) = [(1/ts(g)),(rs(g)/ts(g));(rs(g)/ts(g)),(1/ts(g))];  
        end
        S_mp(:,:,2) = Ip(:,:,2);   
        S_ms(:,:,2) = Is(:,:,2);
          
          for g=3:TotalNumberLayers+1
              
              S_mp(:,:,g) = S_mp(:,:,g-1)*L(:,:,g-1)*Ip(:,:,g);
              S_ms(:,:,g) = S_ms(:,:,g-1)*L(:,:,g-1)*Is(:,:,g);
          end
          
          SSp = S_mp(:,:,TotalNumberLayers+1); 
          SSs = S_ms(:,:,TotalNumberLayers+1); 
          Ibarcohp1=[abs(SSp(1,1))^2, -abs(SSp(1,2))^2; abs(SSp(2,1))^2, ...
              ((det(SSp))^2-abs((SSp(1,2)*SSp(2,1)))^2)/abs(SSp(1,1))^2];
          Ibarcohs1=[abs(SSs(1,1))^2, -abs(SSs(1,2))^2; abs(SSs(2,1))^2, ...
              ((det(SSs))^2-abs((SSs(1,2)*SSs(2,1)))^2)/abs(SSs(1,1))^2];
          rp10(1) = (-((n(1))*cos(phi0)) + ((n0)*cos(phi(1,1))))/(((n(1))*cos(phi0))...
              + ((n0)*cos(phi(1,1)))); 
          rs10(1) = ((-q0 + q(1,1))/(q0 + q(1,1)));
          tp10(1) = (2*q(1,1))/((n(1)*cos(phi0)) + ((n0)*cos(phi(1,1)))); 
          ts10(1) = ((2*q(1,1))/(q0 + q(1,1)));         
          Ibar01p = (1/abs(tp(1))^2)*[1, -abs(rp10(1))^2; abs(rp(1))^2, ...
              abs(tp(1)*tp10(1))^2-abs(rp(1)*rp10(1))^2];
          Ibar01s = (1/abs(ts(1))^2)*[1, -abs(rs10(1))^2; abs(rs(1))^2, ...
              abs(ts(1)*ts10(1))^2-abs(rs(1)*rs10(1))^2];
          Lbar1 = [(abs(exp(-1i*eta(1,1)*t(1))))^2,0;0,(abs(exp(1i*eta(1,1)*t(1))))^2];
          SSpnet=Ibar01p*Lbar1*Ibarcohp1;
          SSsnet=Ibar01s*Lbar1*Ibarcohs1;
          Rpnet = SSpnet(2,1)/SSpnet(1,1);
          Rsnet = SSsnet(2,1)/SSsnet(1,1);
          Tpnet = ((1/SSpnet(1,1))*real(nn(TotalNumberLayers)*...
              cos(phi(TotalNumberLayers,1))))/(n0*cos(phi0));
          Tsnet = ((1/SSsnet(1,1))*real(nn(TotalNumberLayers)*...
              cos(phi(TotalNumberLayers,1))))/(n0*cos(phi0));
          Rnet = (Rpnet+Rsnet)/2;
          Tnet = (Tpnet+Tsnet)/2;
          R(bb,j)=real(Rnet);
          T(bb,j)=real(Tnet);
    end
end

end
