function [Netenergy,Netenergyroof_v,Netenergyroof_inf,Netenergyabser,Netenergyabswr,...
    Netenergypar,Netenergyroof_par]=...
    plantlight_roof2(Peri,Perdi,Pwri,Pwrdi,Pewi,Pewdi,Pwwi,Pwwdi,Pnwi,Pnwdi,...
    Pswi,Pswdi,Ac,Aew_transparent,Anw_transparent,Asw_transparent,Anwins_cond,...
    Pernonactlr,Pwrnonactlr,Perdnonactlr,Pwrdnonactlr)
   
lightdirectv_roof=zeros(8760,1); %Direct solar insolation entering the greenhouse through the
%roofs in the wavelength region between 300 nm to 800 nm (W/m2)
lightdirectv_wall1=zeros(8760,1);%Direct solar insolation entering the greenhouse through the
%east and west wall in the wavelength region between 300 nm to 800 nm (W/m2)
lightdirectv_wall2=zeros(8760,1);%Direct solar insolation entering the greenhouse through the
%south wall in the wavelength region between 300 nm to 800 nm (W/m2)
lightdirectv_wall3=zeros(8760,1);%Direct solar insolation entering the greenhouse through the
%north wall in the wavelength region between 300 nm to 800 nm (W/m2)
lightdirectinf_roof=zeros(8760,1);%Direct solar insolation entering the greenhouse through the
%roofs in the wavelength region between 800 nm to 2000 nm (W/m2)
lightdirectinf_wall1=zeros(8760,1);%Direct solar insolation entering the greenhouse through the
%east and west wall in the wavelength region between 800 nm to 2000 nm (W/m2)
lightdirectinf_wall2=zeros(8760,1);%Direct solar insolation entering the greenhouse through the
%south wall in the wavelength region between 800 nm to 2000 nm (W/m2)
lightdirectinf_wall3=zeros(8760,1);%Direct solar insolation entering the greenhouse through the
%north wall in the wavelength region between 800 nm to 2000 nm (W/m2)
lightdiffuse_roof=zeros(8760,1);%Diffuse solar insolation entering the greenhouse through the
%north wall (W/m2)
lightdiffuse_wall1=zeros(8760,1);%Diffuse solar insolation entering the greenhouse through the
%east and west wall (W/m2)
lightdiffuse_wall2=zeros(8760,1);%Diffuse solar insolation entering the greenhouse through the
%south wall (W/m2)
lightdiffuse_wall3=zeros(8760,1);%Diffuse solar insolation entering the greenhouse through the
%north wall (W/m2)
lightdirectpar_wall1 = zeros(8760,1); %Direct solar insolation entering the greenhouse through the
%east and west wall in the wavelength region between 400 nm to 700 nm (W/m2)
lightdirectpar_wall2 = zeros(8760,1); %Direct solar insolation entering the greenhouse through the
%south wall in the wavelength region between 400 nm to 700 nm (W/m2)
lightdirectpar_wall3 = zeros(8760,1); %Direct solar insolation entering the greenhouse through the
%north wall in the wavelength region between 400 nm to 700 nm (W/m2)
lightdirectpar_roof = zeros(8760,1); %Direct solar insolation entering the greenhouse through the
%roofs in the wavelength region between 400 nm to 700 nm (W/m2)

Netenergyv=zeros(8760,1); %Intensity of solar radiation entering the greenhouse in the
%wavelength between 300 nm to 800 nm (W)
Netenergyinf=zeros(8760,1);%Intensity of solar radiation entering the greenhouse in the
%wavelength between 800 nm to 2000 nm (W)
Netenergy=zeros(8760,1);%Intensity of light entering the greenhouse. 
% 8760x1 matrix consisting intensity for every hour (W)
Netenergyroof_v=zeros(8760,1);%Intensity of light entering the greenhouse from roof in the 
%wavelength region between 300 nm to 800 nm (W). 
Netenergyroof_inf=zeros(8760,1);%Intensity of light entering the greenhouse from roof in the 
%wavelength region between 800 nm to 2000 nm (W). 
Netenergyabser=zeros(8760,1);%Intensity of light absorbed by nonactive layer from OPV stack in east facing roof (W) 
Netenergyabswr=zeros(8760,1);%Intensity of light absorbed by nonactive layer from OPV stack in west facing roof (W)
Netenergypar=zeros(8760,1); %Net energy in the PAR wavelength region (400 - 700 nm) transmitted into the 
%greenhouse from roof and walls (W)
Netenergyroof_par=zeros(8760,1); %Net energy in the PAR wavelength region (400 - 700 nm) transmitted into the 
%greenhouse from roof (W)

for i=1:8760
    lightdirectv_roof(i,1)=(sum(Peri(1:105,i))+sum(Pwri(1:105,i)));
    lightdirectpar_roof(i,1)=(sum(Peri(21:81,i))+sum(Pwri(21:81,i)));
    lightdirectv_wall1(i,1)=(sum(Pewi(1:105,i))+sum(Pwwi(1:105,i)));
    lightdirectv_wall2(i,1)=sum(Pswi(1:105,i));
    lightdirectpar_wall1(i,1)=(sum(Pewi(21:81,i))+sum(Pwwi(21:81,i)));
    lightdirectpar_wall2(i,1)=sum(Pswi(21:81,i));
    Netenergyabser(i,1)=sum(Pernonactlr(:,i))+sum(Perdnonactlr(:,i));
    Netenergyabswr(i,1)=sum(Pwrnonactlr(:,i))+sum(Pwrdnonactlr(:,i));
    if(Anwins_cond==1)
        lightdirectv_wall3(i,1)=0;  
        lightdirectpar_wall3(i,1)=0;
        lightdirectinf_wall3(i,1)=0;
        lightdiffuse_wall3(i,1)=0;
    else
       lightdirectv_wall3(i,1)=sum(Pnwi(1:105,i));
       lightdirectpar_wall3(i,1)=sum(Pnwi(21:81,i));
       lightdiffuse_wall3(i,1) = sum(Pnwdi(:,1));
       lightdirectinf_wall3(i,1)=sum(Pnwi(106:341,i));
    end
    lightdiffuse_roof(i,1) = (sum(Perdi(:,i))+sum(Pwrdi(:,i)));
    lightdiffuse_wall1(i,1) = (sum(Pewdi(:,i))+sum(Pwwdi(:,i)));
    lightdiffuse_wall2(i,1) = sum(Pswdi(:,i));
    lightdirectinf_roof(i,1)=(sum(Peri(106:341,i))+sum(Pwri(106:341,i)));
    lightdirectinf_wall1(i,1)=(sum(Pewi(106:341,i))+sum(Pwwi(106:341,i)));
    lightdirectinf_wall2(i,1)=sum(Pswi(106:341,i));
    Netenergyv(i,1)=((lightdirectv_roof(i,1)+lightdiffuse_roof(i,1))*(Ac/2))...
    +((lightdirectv_wall1(i,1)+lightdiffuse_wall1(i,1))...
     *Aew_transparent)+((lightdirectv_wall2(i,1)+...
     lightdiffuse_wall2(i,1))*Asw_transparent)+...
    ((lightdirectv_wall3(i,1)+lightdiffuse_wall3(i,1))...
    *Anw_transparent);
    Netenergypar(i,1)=((lightdirectpar_roof(i,1)+lightdiffuse_roof(i,1))*(Ac/2))...
    +((lightdirectpar_wall1(i,1)+lightdiffuse_wall1(i,1))...
    *Aew_transparent)+((lightdirectpar_wall2(i,1)+...
    lightdiffuse_wall2(i,1))*Asw_transparent)+...
    ((lightdirectpar_wall3(i,1)+lightdiffuse_wall3(i,1))...
    *Anw_transparent);
    Netenergyvwall(i,1)=((lightdirectv_wall1(i,1)+lightdiffuse_wall1(i,1))...
     *Aew_transparent)+((lightdirectv_wall2(i,1)+...
     lightdiffuse_wall2(i,1))*Asw_transparent)+...
    ((lightdirectv_wall3(i,1)+lightdiffuse_wall3(i,1))...
    *Anw_transparent);
    Netenergyroof_v(i,1)=((lightdirectv_roof(i,1)+lightdiffuse_roof(i,1))*(Ac/2));
    Netenergyroof_par(i,1)=((lightdirectpar_roof(i,1)+lightdiffuse_roof(i,1))*(Ac/2));
    Netenergyroof_inf(i,1)=(lightdirectinf_roof(i,1))*(Ac/2);
    Netenergyinf(i,1)=(lightdirectinf_roof(i,1))*(Ac/2)+...
    (lightdirectinf_wall1(i,1)*Aew_transparent)+...
    (lightdirectinf_wall2(i,1)*Asw_transparent)+...
    (lightdirectinf_wall3(i,1)*Anw_transparent);
     Netenergyinfwall(i,1)=(lightdirectinf_wall1(i,1)*Aew_transparent)+...
    (lightdirectinf_wall2(i,1)*Asw_transparent)+...
    (lightdirectinf_wall3(i,1)*Anw_transparent);
    Netenergy(i,1)=(Netenergyv(i,1)+Netenergyinf(i,1));
end
end