%Calculating light entering the greenhouse and power generation from OPV
%stack
function [Ter,Twr,Tew,Tww,Tnw,Tsw,Rer,Rwr,Rew,Rww,Rnw,Rsw,Per,Pwr,Pew,Pww,Pnw,Psw,...
 Perd,Pwrd,Pewd,Pwwd,Pnwd,Pswd,Peri,Perdi,Pwri,Pwrdi,Pewi,Pewdi,Pwwi,Pwwdi,Pnwi,Pnwdi,...
 Pswi,Pswdi,...
 Pouter,Pouterd,Poutwr,Poutwrd,PCEer,PCEwr,PCEd,PCEernet,PCEwrnet,...
 Pernonactlr,Pwrnonactlr,Perdnonactlr,Pwrdnonactlr,EAI_average,WallEAI_average]...
    =powergen_roof2_126(R,Transmittance,Abstotal_check,lambda_sm,R_glass,T_glass,Eastroof,Westroof,...
    Eastwall,Westwall,Northwall,Southwall,Suner,Sunerd,Sunwr,Sunwrd,Sunew,Sunewd,Sunww,...
    Sunwwd,Sunnw,Sunnwd,Sunsw,Sunswd,fraclight,Anwins_cond,C,h,qe,M,Voc,FF,TA,...
    Sunerr,Sunwrr,pcov)
q=1.6e-19; %Charge of electron (C)
Eg=0.91; %Bandgap (eV)
non_ideality=1.48; %Voc non ideality factor
non_idealitymod=1.5; %Voc non ideality factor
J00=0.06; %Current prefactor
T=298; %Temperature (K)
kb=1.38e-23; %Boltzmann constant (m2 kg s-2 K-1) 
Absnonactlr=1-R-Transmittance-Abstotal_check; %Absorptance in the non active layer region of the OPV stack 
Absnonactlr(Absnonactlr < 0) = 0;
Rer=zeros(M,8760);        %Reflectance matrix for OPV on east facing roof for OPV stack as a function of 
%wavelength and angle(hourly solar incidence angles over a period of a year)
Rwr=zeros(M,8760);        %Reflectance matrix for OPV on west facing roof for OPV stack as a function of 
%wavelength and angle(hourly solar incidence angles over a period of a year)
Rew=zeros(M,8760);        %Reflectance matrix of east facing wall for OPV stack as a function of 
%wavelength and angle(hourly solar incidence angles over a period of a year)
Rww=zeros(M,8760);        %Reflectance matrix of west facing wall for OPV stack as a function of 
%wavelength and angle(hourly solar incidence angles over a period of a year)
Rnw=zeros(M,8760);        %Reflectance matrix of north facing wall for OPV stack as a function of 
%wavelength and angle(hourly solar incidence angles over a period of a year)
Rsw=zeros(M,8760);        %Reflectance matrix of south facing wall for OPV stack as a function of 
%wavelength and angle(hourly solar incidence angles over a period of a year)
Ter=zeros(M,8760);        %Transmittance matrix for OPV on east facing roof as a function of 
%wavelength and angle(hourly solar incident angles for a period of year)
Twr=zeros(M,8760);        %Transmittance matrix for OPV on west facing roof as a function of 
%wavelength and angle(hourly solar incident angles for a period of year)
Tew=zeros(M,8760);        %Transmittance matrix of east facing wall for active layer as a function of 
%wavelength and angle(hourly solar incident angles for a period of year)
Tww=zeros(M,8760);        %Transmittance matrix of west facing wall for active layer as a function of 
%wavelength and angle(hourly solar incident angles for a period of year)
Tnw=zeros(M,8760);        %Transmittance matrix of north facing wall for active layer as a function of 
%wavelength and angle(hourly solar incident angles for a period of year)
Tsw=zeros(M,8760);        %Transmittance matrix of south facing wall for active layer as a function of 
%wavelength and angle(hourly solar incident angles for a period of year)
Eastroof=round(Eastroof); %Round off angle of incidence of east facing roof (degrees)
Westroof=round(Westroof); %Round off angle of incidence of west facing roof (degrees)
Eastwall=round(Eastwall); %Round off angle of incidence of east facing wall (degrees)
Westwall=round(Westwall); %Round off angle of incidence of west facing wall (degrees)
Northwall=round(Northwall); %Round off angle of incidence of north facing wall (degrees)
Southwall=round(Southwall); %Round off angle of incidence of south facing wall (degrees)
%Loop starts
%Outer loop is for wavelength
%Inner loop is for hours of a year 
for bb=1:M
    for i=1:8760
        %For the case of angle of incidence perpendicular to the normal to
        %the surface
        if(Eastroof(i,1)==90)
                
                Ter(bb,i)=0;    %Transmittance is zero
                Rer(bb,i)=1;    %Reflectance is one
        else
            
            for j=1:90      %Outer loop denoting rangle of possible angle of incidences
            
            if(Eastroof(i,1)==j) %If one of the angle values of j matches with the angle of incidence of sunlight 
                %on the roof, then
               
              Ter(bb,i)=(pcov*Transmittance(bb,j+1))+((1-pcov)*T_glass(bb,j+1));
              Rer(bb,i)=(pcov*R(bb,j+1))+((1-pcov)*R_glass(bb,j+1));
            end
            end
        end
        
         if(Westroof(i,1)==90)
                
                Twr(bb,i)=0;    
                Rwr(bb,i)=1;
        else
            
            for j=1:90      %Outer loop denoting rangle of possible angle of incidences
            
            if(Westroof(i,1)==j) %If one of the angle values of j matches with the angle of incidence of sunlight 
                %on the roof, then
               
              Twr(bb,i)=(pcov*Transmittance(bb,j+1))+((1-pcov)*T_glass(bb,j+1));
              Rwr(bb,i)=(pcov*R(bb,j+1))+((1-pcov)*R_glass(bb,j+1));
            end
            end
        end
        
        if(Eastwall(i,1)==90)
                
                Tew(bb,i)=0;  
                Rew(bb,i)=1;
        else
            
            for j=1:90      
            
            if(Eastwall(i,1)==j) 
               
              Tew(bb,i)=T_glass(bb,j+1); 
              Rew(bb,i)=R_glass(bb,j+1);
            end
            end
        end
        
        if(Westwall(i,1)==90)
                
                Tww(bb,i)=0; 
                Rww(bb,i)=1;
        else
            
            for j=1:90      
            
            if(Westwall(i,1)==j) 
               
              Tww(bb,i)=T_glass(bb,j+1); 
              Rww(bb,i)=R_glass(bb,j+1);
              
              
            end
            end
        end
        
          if(Northwall(i,1)==90)
                
                Tnw(bb,i)=0;  
                Rnw(bb,i)=1;
        else
            
            for j=1:90      
            
            if(Northwall(i,1)==j) 
               
              Tnw(bb,i)=T_glass(bb,j+1); 
              Rnw(bb,i)=R_glass(bb,j+1);
            end
            end
          end
          
           if(Southwall(i,1)==90)
                
                Tsw(bb,i)=0; 
                Rsw(bb,i)=1;
        else
            
            for j=1:90      
            
            if(Southwall(i,1)==j)   
              Tsw(bb,i)=T_glass(bb,j+1);
              Rsw(bb,i)=R_glass(bb,j+1);
            end
            end
           end
    end
end
absactlrer=zeros(M,8760); %Absorptance matrix for OPV on east facing roof for 
%active layer as a function of wavelength and angle(hourly solar
%incidence angles over a period of a year)
absactlrwr=zeros(M,8760); %Absorptance matrix for OPV on west facing roof for 
%active layer as a function of wavelength and angle(hourly solar
%incidence angles over a period of a year)
absnonactlrer=zeros(M,8760); %Absorptance matrix for OPV on east facing roof for 
%nonactive layer in OPV stack as a function of wavelength and angle(hourly solar
%incidence angles over a period of a year)
absnonactlrwr=zeros(M,8760);%Absorptance matrix for OPV on east facing roof for 
%nonactive layer of OPV stack as a function of wavelength and angle(hourly solar
%incidence angles over a period of a year)
for bb=1:M
    for i=1:8760
        if(Eastroof(i,1)==90)
            absactlrer(bb,i)=0; %Absorptance in the active layer is assigned 0
            absnonactlrer(bb,i)=0; %Absorptance in the nonactive layer is assigned 0
            
        else
            for j=1:90
                if(Eastroof(i,1)==j)
              absactlrer(bb,i)=Abstotal_check(bb,j+1);
              absnonactlrer(bb,i)=Absnonactlr(bb,j+1);
                end
            end
        end
        
        if(Westroof(i,1)==90)
            absactlrwr(bb,i)=0;
            absnonactlrwr(bb,i)=0;
            
        else
            for j=1:90
                if(Westroof(i,1)==j)
              absactlrwr(bb,i)=Abstotal_check(bb,j+1);
              absnonactlrwr(bb,i)=Absnonactlr(bb,j+1);
                end
            end
        end
    end
end

   EAI_average=59.7-0.1388*(TA)+(0.001497*(TA^2)); %Average equivalent angle of incidence
   EAI_average=round(EAI_average);
   EAIr_average=90-(0.5788*TA)+(0.002693*TA*TA);
   EAIr_average=round(EAIr_average);
   WallEAI_average=59.7-0.1388*(90)+(0.001497*(90^2)); %Average equivalent angle of incidence for wall
   WallEAI_average=round(WallEAI_average);
   Tsaea_wall=T_glass(:,WallEAI_average);
   Tsaea=(pcov*Transmittance(:,EAI_average+1))+((1-pcov)*T_glass(:,EAI_average+1));
   Tsaear=(pcov*Transmittance(:,EAIr_average))+((1-pcov)*T_glass(:,EAIr_average));
Ad=Abstotal_check(:,EAI_average+1);%Absorptance of diffuse radiation in the active layer of OPV stack
Adr=Abstotal_check(:,EAIr_average+1);
Adnonact=Absnonactlr(:,EAI_average+1); %Absorptance of diffuse radiation in the nonactive layer of OPV stack
Adrnonact=Absnonactlr(:,EAIr_average+1); 


%Calculating power generated


Per=zeros(M,8760);      %Power of direct light in each wavelength at a particular hour of a day/month/year that is 
%incident on the east facing roof (W/m2-nm)
Pernonactlr=zeros(M,8760); %Power of direct light in each wavelength at a particular hour of a day/month/year that 
%is absorbed on the east facing roof in the nonactivelayer of OPV stack 
%(W/m2-nm)
Pwr=zeros(M,8760); %Power of direct light in each wavelength at a particular hour of a day/month/year that is 
%incident on the west facing roof (W/m2-nm)
Pew=zeros(M,8760); %Power of direct light in each wavelength at a particular hour of a day/month/year that is 
%incident on the east facing wall (W/m2-nm)
Pwrnonactlr=zeros(M,8760); %Power of direct light in each wavelength at a particular hour of a day/month/year that 
%is absorbed on the west facing roof in the nonactivelayer of OPV stack
%(W/m2-nm)
Pww=zeros(M,8760); %Power of direct light in each wavelength at a particular hour of a day/month/year that is 
%incident on the west facing wall (W/m2-nm)
Pnw=zeros(M,8760); %Power of direct light in each wavelength at a particular hour of a day/month/year that is 
%incident on the north facing wall (W/m2-nm)
Psw=zeros(M,8760); %Power of direct light in each wavelength at a particular hour of a day/month/year that is 
%incident on the south facing wall (W/m2-nm)
Perd=zeros(M,8760);%Power of diffuse light in each wavelength at a particular hour of a day/month/year that is 
%incident on the east facing roof  (W/m2-nm)  
Perr=zeros(M,8760);
Perdnonactlr=zeros(M,8760); %Power of diffuse light in each wavelength at a particular hour of a day/month/year 
%that is absorbed on the east facing roof in the nonactivelayer of OPV stack
%(W/m2-nm)
Perrnonactlr=zeros(M,8760);
Pwrd=zeros(M,8760); %Power of diffuse light in each wavelength at a particular hour of a day/month/year that is 
%incident on the west facing roof (W/m2-nm)
Pwrr=zeros(M,8760);
Pwrdnonactlr=zeros(M,8760); %Power of diffuse light in each wavelength at a particular hour of a day/month/year 
%that is absorbed on the east facing roof in the nonactivelayer of OPV stack
%(W/m2-nm)
Pwrrnonactlr=zeros(M,8760);
Pewd=zeros(M,8760); %Power of diffuse light in each wavelength at a particular hour of a day/month/year that is 
%incident on the east facing wall (W/m2-nm)
Pwwd=zeros(M,8760); %Power of diffuse light in each wavelength at a particular hour of a day/month/year that is 
%incident on the west facing wall (W/m2-nm)
Pnwd=zeros(M,8760); %Power of diffuse light in each wavelength at a particular hour of a day/month/year that is 
%incident on the north facing wall (W/m2-nm)
Pswd=zeros(M,8760); %Power of diffuse light in each wavelength at a particular hour of a day/month/year that is 
%incident on the south facing wall (W/m2-nm)
Pouter=zeros(8760,1);   %Power generated for the corresponding hour for a south facing roof (W/m2)
Poutwr=zeros(8760,1);   %Power generated for the corresponding hour for a north facing roof (W/m2)
jscer=zeros(8760,1);   %Cumulative diffuse Short circuit current for all wavelengths for a particular 
%hour/day/month/year for a east facing roof (A/m2)  
jscwr=zeros(8760,1);   %Cumulative diffuse Short circuit current for all wavelengths for a particular 
%hour/day/month/year for a west facing roof  (A/m2)
jscerd=zeros(8760,1);   %Cumulative diffuse Short circuit current for all wavelengths for a particular 
%hour/day/month/year for a east facing roof  (A/m2)
jscerr=zeros(8760,1);
jscwrd=zeros(8760,1);   %Cumulative diffuse Short circuit current for all wavelengths for a particular 
%hour/day/month/year for a west facing roof  (A/m2)
jscwrr=zeros(8760,1);
Pouterd=zeros(8760,1);  %Diffuse Power generated for the corresponding hour for a east facing roof (W/m2)
Poutwrd=zeros(8760,1);  %Diffuse Power generated for the corresponding hour for a west facing roof (W/m2)
PCEer = zeros(8760,1);  %Power Conversion Efficiency for OPV stack for east facing roof 
PCEwr = zeros(8760,1);  %Power Conversion Efficiency for OPV stack for west facing roof
PCEd = zeros(8760,1);   %Power Conversion Efficiency for OPV stack for diffuse radiation
PCEernet=zeros(8760,1); %Net Power Conversion Efficiency for east facing roof
PCEwrnet=zeros(8760,1); %Net Power Conversion Efficiency for west facing roof
num=xlsread('IQE.xlsx');
IQE_osc=num(:,2);
for i=1:8760
    for bb=1:M
        Per(bb,i)=fraclight(bb,1)*Suner(i,1);
        Pernonactlr(bb,i)=Per(bb,i)*absnonactlrer(bb,i);
        Pwr(bb,i)=fraclight(bb,1)*Sunwr(i,1);
        Pwrnonactlr(bb,i)=Pwr(bb,i)*absnonactlrwr(bb,i);
        jscer(i,1)=jscer(i,1)+(((IQE_osc(bb,1)*qe)/(h*C))*(Per(bb,i)*lambda_sm(1,bb)*absactlrer(bb,i)));
        jscwr(i,1)=jscwr(i,1)+(((IQE_osc(bb,1)*qe)/(h*C))*(Pwr(bb,i)*lambda_sm(1,bb)*absactlrwr(bb,i)));
        Pew(bb,i)=fraclight(bb,1)*Sunew(i,1);
        Pww(bb,i)=fraclight(bb,1)*Sunww(i,1);
        Pnw(bb,i)=fraclight(bb,1)*Sunnw(i,1);
        Psw(bb,i)=fraclight(bb,1)*Sunsw(i,1);
        Perd(bb,i)=fraclight(bb,1)*Sunerd(i,1);
        Perr(bb,i)=fraclight(bb,1)*Sunerr(i,1);
        Perdnonactlr(bb,i)=Perd(bb,i)*Adnonact(bb,1);
        Perrnonactlr(bb,i)=Perr(bb,i)*Adrnonact(bb,1);
        Pwrd(bb,i)=fraclight(bb,1)*Sunwrd(i,1);
        Pwrr(bb,i)=fraclight(bb,1)*Sunwrr(i,1);
        Pwrdnonactlr(bb,i)=Pwrd(bb,i)*Adnonact(bb,1);
        Pwrrnonactlr(bb,i)=Pwrr(bb,i)*Adrnonact(bb,1);
        jscerd(i,1)=jscerd(i,1)+(((IQE_osc(bb,1)*qe)/(h*C))*(Perd(bb,i)*lambda_sm(1,bb)*Ad(bb,1)));
        jscerr(i,1)=jscerr(i,1)+(((IQE_osc(bb,1)*qe)/(h*C))*(Perr(bb,i)*lambda_sm(1,bb)*Adr(bb,1)));
        jscwrd(i,1)=jscwrd(i,1)+(((IQE_osc(bb,1)*qe)/(h*C))*(Pwrd(bb,i)*lambda_sm(1,bb)*Ad(bb,1)));
        jscwrr(i,1)=jscwrr(i,1)+(((IQE_osc(bb,1)*qe)/(h*C))*(Pwrr(bb,i)*lambda_sm(1,bb)*Adr(bb,1)));
        Pewd(bb,i)=fraclight(bb,1)*Sunewd(i,1);
        Pwwd(bb,i)=fraclight(bb,1)*Sunwwd(i,1);
        Pnwd(bb,i)=fraclight(bb,1)*Sunnwd(i,1);
        Pswd(bb,i)=fraclight(bb,1)*Sunswd(i,1);
    end
end
jscerdnet=jscerd+jscerr+jscer;
jscwrdnet=jscwrd+jscwrr+jscwr;
J0=J00*exp(-Eg*q/(2*non_idealitymod*kb*T));
for i=1:8760
if(jscerdnet(i,1)==0)
    Voc1(i,1)=0;
else
    Voc1(i,1)=(non_ideality*kb*T/q)*log(jscerdnet(i,1)/J0);
end
if(jscwrdnet(i,1)==0)
    Voc2(i,1)=0;
else
    Voc2(i,1)=(non_ideality*kb*T/q)*log(jscwrdnet(i,1)/J0);
end
end
for i=1:8760
    Pouter(i,1)=Voc1(i,1)*FF*jscer(i,1); 
    Pouter(i,1)=Pouter(i,1)*pcov;
    Poutwr(i,1)=Voc2(i,1)*FF*jscwr(i,1);
    Poutwr(i,1)=Poutwr(i,1)*pcov;
    Pouterd(i,1)=Voc1(i,1)*FF*(jscerdnet(i,1)-jscer(i,1));
    Pouterd(i,1)=Pouterd(i,1)*pcov;
    Poutwrd(i,1)=Voc2(i,1)*FF*(jscwrdnet(i,1)-jscwr(i,1));
    Poutwrd(i,1)=Poutwrd(i,1)*pcov;
    if(Suner(i,1)==0)
        PCEer(i,1)=0;
    else
        PCEer(i,1)=((Pouter(i,1))/((Suner(i,1))))*100;
    end
    
    if(Sunwr(i,1)==0)
        PCEwr(i,1)=0;
    else
        PCEwr(i,1)=((Poutwr(i,1))/((Sunwr(i,1))))*100;
    end
    
    if(Sunerd(i,1)==0)
        PCEd(i,1)=0;
    else
        PCEd(i,1)=((Pouterd(i,1))/((Sunerd(i,1))))*100;
    end
    if(Suner(i,1)==0&&Sunerd(i,1)==0)
        PCEernet(i,1)=0;
    else
        PCEernet(i,1)=((Pouter(i,1)+Pouterd(i,1))/((Suner(i,1)+Sunerd(i,1))))*100;
    end
    
    if(Sunwr(i,1)==0&&Sunwrd(i,1)==0)
        PCEwrnet(i,1)=0;
    else
       PCEwrnet(i,1)=((Poutwr(i,1)+Poutwrd(i,1))/((Sunwr(i,1)+Sunwrd(i,1))))*100;
    end
end

%Obtaining spectrum of light entering the greenhouse through the roof
Perdi=zeros(M,8760);%Intensity of diffuse light entering the greenhouse through a east facing roof as a 
    %function of wavelength and angle of incidence based on hours (W/m2)
Pwrdi=zeros(M,8760);%Intensity of diffuse light entering the greenhouse through a west facing roof as a 
    %function of wavelength and angle of incidence based on hours (W/m2)
Pewdi=zeros(M,8760);%Intensity of diffuse light entering the greenhouse through a east facing wall as a 
    %function of wavelength and angle of incidence based on hours (W/m2)
Pwwdi=zeros(M,8760);%Intensity of diffuse light entering the greenhouse through a west facing wall as a 
    %function of wavelength and angle of incidence based on hours (W/m2)
Pnwdi=zeros(M,8760);%Intensity of diffuse light entering the greenhouse through a north facing wall as a 
    %function of wavelength and angle of incidence based on hours (W/m2)
Pswdi=zeros(M,8760);%Intensity of diffuse light entering the greenhouse through a south facing wall as a 
    %function of wavelength and angle of incidence based on hours (W/m2)
Peri=Per.*Ter;%Intensity of direct light entering the greenhouse through a east facing roof as a function 
%of wavelength and angle of incidence based on hours (W/m2)
Pwri=Pwr.*Twr;%Intensity of direct light entering the greenhouse through a west facing roof as a function 
%of wavelength and angle of incidence based on hours (W/m2)
Pewi=Pew.*Tew;%Intensity of direct light entering the greenhouse through a east facing wall as a function 
%of wavelength and angle of incidence based on hours (W/m2)
Pwwi=Pww.*Tww;%Intensity of direct light entering the greenhouse through a west facing wall as a function 
%of wavelength and angle of incidence based on hours (W/m2)
Pnwi=Pnw.*Tnw;%Intensity of direct light entering the greenhouse through a north facing wall as a function 
%of wavelength and angle of incidence based on hours (W/m2)
Pswi=Psw.*Tsw;%Intensity of direct light entering the greenhouse through a south facing wall as a function 
%of wavelength and angle of incidence based on hours (W/m2)
for bb=1:M
    for i=1:8760
        Perdi(bb,i)=(Perd(bb,i)*Tsaea(bb,1))+(Perr(bb,i)*Tsaear(bb,1));
        Pwrdi(bb,i)=(Pwrd(bb,i)*Tsaea(bb,1))+(Pwrr(bb,i)*Tsaear(bb,1));
        Pewdi(bb,i)=Pewd(bb,i)*Tsaea_wall(bb,1);
        Pwwdi(bb,i)=Pwwd(bb,i)*Tsaea_wall(bb,1);
        Pnwdi(bb,i)=Pnwd(bb,i)*Tsaea_wall(bb,1);
        Pswdi(bb,i)=Pswd(bb,i)*Tsaea_wall(bb,1);
    end
end

if(Anwins_cond==1)
    Pnwi=zeros(341,8760);
    Pnwdi=zeros(341,8760);
end

end
          
    