function [Wmatrix_combined,WFmatrix_combined,LAImatrix_combined] = tomato(DLI_inside,th,sunrise,sunset,CO2)

PPFD=DLI_inside*1e6/(24*3600);
for i=1:365
    T(i,1)=mean(th((i*24)-23:(i*24),3));
    th_temp=th((i*24)-23:(i*24),3);
    Tdaytime(i,1)=mean(th_temp(sunrise(i,1):sunset(i,1),1));
end
%T = 25.2;
Nm = 0.5; %done
Nprev = 2.17; %done
rho = 4.2; %done
delta = 0.038; %done
beta = 0.169; %done
Nb = 16; %done
LAIprev = 0.0028;%done
LAImax = 5; %done
E = 0.7; %done
D = 2.593; %done
tau = 0.0693; %done
LFmax = tau*CO2; %done
K = 0.58; %done
m = 0.1; %done
Qe = 0.0645; %done
%PPFD = 230;
WFprev = 0; %done
Wprev=0; %done
Q10 = 1.4; %done
RL = 0.015; %done
RF = 0.010; %done
fFTd = 0.95; %done
%Tdaytime = 26.2;
Tcrit = 24.4;%done
NFF = 22; %done
alphaF = 0.8; %done
nu = 0.135; %done
p1=2; %done
day = 1;
daylim=365;
k=1;
%% Temperature and node dependent properties
temp = [0,9,12,28,50];
fnT = [0,0,0.55,1,0];
lambdaTd  = [0,0,0.55,1,0];

temp2 = [0,9,12,15,21,28,35,50];
PGREDT = [0,0.67,1,1,1,1,0,0]; 

nodenumber = [1,12,21,30,50,90];
fRN = [0.2,0.15,0.10,0.07,0.07,0.07];

temp_size=size(temp);
temp_size=temp_size(2);

temp2_size=size(temp2);
temp2_size=temp2_size(2);

nodenumber_size=size(nodenumber);
nodenumber_size=nodenumber_size(2);
daycnt=1;
while(day<=daylim)
    if(day==180)
        Nprev = 2.17; %done
        rho = 4.2; %done
        LAIprev = 0.0028;%done
        LAImax = 5; %done
        WFprev = 0; %done
        Wprev=0; %done
        k=k+1;
        daycnt=1;
    end
    T1=T(day,1);
    Tdaytime1=Tdaytime(day,1);
    ctrl=0;
    if(T1<temp(1)||T1>temp(temp_size))
        fnT1=0;
        lambdaTd1=0;
        ctrl=1;
    else
        for i=1:temp_size
            if(T1==temp(i))
                fnT1=fnT(i);
                lambdaTd1=lambdaTd(i);
                ctrl=1;
                break;
            
            end
        end
    end
    if(ctrl==0)
        for i=1:temp_size-1
            if(T1>temp(i)&&T1<temp(i+1))
                fnT1=(((fnT(i+1)-fnT(i))/(temp(i+1)-temp(i)))*(T1-temp(i)))+fnT(i);
                lambdaTd1=(((lambdaTd(i+1)-lambdaTd(i))/(temp(i+1)-temp(i)))*(T1-temp(i)))+lambdaTd(i);
            end
        end
    end

    ctrl=0;
    if(T1<temp2(1)||T1>temp2(temp2_size))
        PGREDT1=0;
        ctrl=1;
    else
        for i=1:temp2_size
            if(T1==temp2(i))
                PGREDT1=PGREDT(i);
                ctrl=1;
                break;
            
            end
        end
    end
    if(ctrl==0)
        for i=1:temp2_size-1
            if(T1>temp2(i)&&T1<temp2(i+1))
            PGREDT1=(((PGREDT(i+1)-PGREDT(i))/(temp2(i+1)-temp2(i)))*(T1-temp2(i)))+PGREDT(i);
            
            end
        end
    end

    ctrl=0;
    if(Nprev>nodenumber(nodenumber_size))
        fRN1=fRN(nodenumber_size);
        ctrl=1;
    else
        for i=1:nodenumber_size
            if(Nprev==nodenumber(i))
                fRN1=fRN(i);
                ctrl=1;
                break;
            
            end
        end
    end
    if(ctrl==0)
        for i=1:nodenumber_size-1
            if(Nprev>nodenumber(i)&&Nprev<nodenumber(i+1))
                fRN1=(((fRN(i+1)-fRN(i))/(nodenumber(i+1)-nodenumber(i)))*(Nprev-nodenumber(i)...
                    ))+fRN(i);
            
            end
        end
    end

%% State variable  1
    dNdt = Nm*fnT1;
    Nnow=dNdt+Nprev;
    
%% State variable 2

    dLAIdt = rho*delta*lambdaTd1*(exp(beta*(Nnow-Nb))/(1+exp(beta*(Nnow-Nb))))*dNdt;
    LAInow = dLAIdt + LAIprev;
    if (LAInow >LAImax)
        LAInow = LAImax;
    end


%% State variable 3

    Pg = (D*LFmax*PGREDT1/K)*log((((1-m)*LFmax)+(Qe*K*PPFD(day,1)))/(((1-m)*LFmax)+(Qe*K*PPFD(day,1)*...
        exp(-K*LAInow))));
    Rm = (Q10^(0.1*(T1-2)))*((RL*(Wprev-WFprev))+(RF*WFprev));

    GRnet = E*(Pg-Rm)*(1-fRN1);

    if(Tdaytime1>Tcrit)
        gTdaytime = 1-0.154*(Tdaytime1 - Tcrit);
    else
        gTdaytime = 1;
    end
    if(Nnow>NFF)
    dWFdt = GRnet*alphaF*fFTd*(1-exp(-nu*(Nnow-NFF)))*gTdaytime;
    else
        dWFdt = 0;
    end
    WFnow = WFprev + dWFdt;

%% State variable 4
    if(LAInow<LAImax)
        dWdt = GRnet;
    else
        dWdt = GRnet-p1*rho*dNdt;
    end
    Vmax=8;
    if(LAInow<LAImax)
        dWdtmax = GRnet+((Vmax)*rho*dNdt);
    else
        dWdtmax = GRnet+((Vmax-p1)*rho*dNdt);
    end
    dWdt=min(dWdt,dWdtmax);
    if(LAInow<LAImax)
        GRnet=dWdt;
    else
        GRnet=dWdt+p1*rho*dNdt;
    end
    Wnow=Wprev+dWdt;
    if(Nnow>NFF)
    dWFdt = GRnet*alphaF*fFTd*(1-exp(-nu*(Nnow-NFF)))*gTdaytime;
    else
        dWFdt = 0;
    end
    WFnow = WFprev + dWFdt;
%% Tabulating parameters
    W_matrix(daycnt,k)=Wnow;
    WF_matrix(daycnt,k)=WFnow;
    LAI_matrix(daycnt,k)=LAInow;
    node_matrix(daycnt,k)=Nnow;
    Wprev=Wnow;
    WFprev=WFnow;
    LAIprev=LAInow;
    Nprev=Nnow;
    day=day+1;
    daycnt=daycnt+1;
end
Wmatrix_combined(1:179,1)=W_matrix(1:179,1);
Wmatrix_combined(180:365,1)=W_matrix(1:186,2);
Wmatrix_combined(180,1)=NaN;
WFmatrix_combined(1:179,1)=WF_matrix(1:179,1);
WFmatrix_combined(180:365,1)=WF_matrix(1:186,2);
WFmatrix_combined(180,1)=NaN;
LAImatrix_combined(1:179,1)=LAI_matrix(1:179,1);
LAImatrix_combined(180:365,1)=LAI_matrix(1:186,2);
LAImatrix_combined(180,1)=NaN;
%load('Tomgro_validation.mat');
totalannualfruitweight=WFmatrix_combined(179,1)+WFmatrix_combined(365,1);
end
%water content 98%
% days=1:1:daylim;
% days=days';
% figure(1)
% plot(days,Wmatrix_combined);
% figure(2)
% plot(days,WFmatrix_combined);
% figure(3)
% plot(days,LAImatrix_combined);
% save('Az_plntsimulation_slachange_heatlamps_LED.mat',...
%     'Wmatrix_combined','WFmatrix_combined','LAImatrix_combined','-append');